// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112324, 0.08417937871268441, -0.11664236870396069, 0.0, -0.1468200342221037, 0.07290148043997573, -0.10101525445522092 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.13468700594029503, 0.09720197391996736, 0.2605797108646139, -0.12987926104263015, 0.09768798378956754, -0.06313453403451338 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536857, 0.34992710611188216, 0.0, 0.06776309271789394, -0.1458029608799512, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647918, 0.23570226039551614, -0.27216552697590857, -0.12026755886059132, 0.14682003422210377, -0.2245365597551249, 0.17677669529663703 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179751, -0.08417937871268394, -0.3499271061118825, 0.0, -0.033881546358947, -0.07290148043997534, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.0608580619450188, 0.0, 0.21384434262392826, 0.06013377943029566, 0.03952847075210458, 0.11226827987756255, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112294, 0.084179378712684, 0.11664236870396068, 0.0, 0.1468200342221034, 0.07290148043997532, 0.10101525445522092 },
          { 0.0, 0.0, 0.0, 0.49121149998479186, 0.21886638465297908, 0.21384434262392799, -0.2605797108646134, 0.016940773179473304, -0.024786503349591836, 0.037880720420708 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359528, -0.1683587574253683, -0.3499271061118822, 0.0, -0.06776309271789384, -0.14580296087995082, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.4040610178208842, -0.622092633087791, 0.1202675588605911, 0.07905694150420942, 0.07873359887517378, -0.12626906806902655 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268426, 0.34992710611188216, 0.0, 0.033881546358946836, -0.07290148043997557, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.09998110176681574, -0.08417937871268404, 0.5637714487358109, -0.06013377943029572, 0.07341001711105194, -0.185169760317538, 0.1641497884897344 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, 0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052533, -0.14580296087995084, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268419, 0.11664236870396132, 0.16035674514745446, 0.06776309271789377, 0.03207665139358955, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719485, 0.0, 0.18070158058105062, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014799, -0.0777615791359743, -0.32071349029490914, 0.0903507902905255, -0.06415330278717904, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566363, 0.3110463165438965, 0.0, -0.09035079029052517, 0.1458029608799512, -0.20203050891044172 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297953, 0.19440394783993506, 0.1603567451474548, -0.15811388300841947, 0.17787961227354074, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678166015, -0.4761904761904763, -1.6495721976846462, 0.0, -0.31943828249997114, -0.4123930494211606, 0.5714285714285698 },
          { 0.0, 0.0, 0.0, 0.6147592613027619, 0.47619047619047594, -0.5498573992282142, 0.56694670951384, 0.1597191412499856, -0.4536323543632768, 0.3571428571428567 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789405, 1.8079567149113942, 0.0, 0.0, -0.5868455973269657, -1.262690680690262, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389457, 1.1664236870396074, -0.33671751485073614, 1.041547612244118, 0.684653196881458, -0.58083771311752, 0.21870444131992506 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.999999999999999, 0.13041013273932608, -0.8417937871268405, 0.9331389496316881, 0.0, 0.11293848786315719, -0.729014804399755, -2.0203050891044194 },
          { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073864, 1.3608276348795436, -0.20044593143431821, 0.6211616832473612, 0.5977921396077994, -0.883883476483185 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871877, 0.4761904761904753, -0.5498573992282163, 0.0, -0.6388765649999408, 0.41239304942116123, -0.14285714285714265 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.1736911946539295, 0.0, 0.0 },
          { 0.0, 3.999999999999995, 0.0, 0.6776309271789406, -0.5248906591678216, 0.0, -2.083095224488238, 0.5868455973269637, -0.10101525445522308, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 },
          { 0.0, 0.0, 4.0, 0.825930840682394, 0.8417937871268399, -1.7885163201274028, 0.0, -1.1293848786315663, 0.7290148043997556, -0.2525381361380524 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112324, 0.08417937871268441, -0.11664236870396069, 0.0, -0.1468200342221037, 0.07290148043997573, -0.10101525445522092 },
          { 0.0, 0.0, 0.0, 0.32167832742366903, -0.13468700594029503, 0.09720197391996736, 0.2605797108646139, -0.12987926104263015, 0.09768798378956754, -0.06313453403451338 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536857, 0.34992710611188216, 0.0, 0.06776309271789394, -0.1458029608799512, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, -0.16518616813647918, 0.23570226039551614, -0.27216552697590857, -0.12026755886059132, 0.14682003422210377, -0.2245365597551249, 0.17677669529663703 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179751, -0.08417937871268394, -0.3499271061118825, 0.0, -0.033881546358947, -0.07290148043997534, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, 0.0608580619450188, 0.0, 0.21384434262392826, 0.06013377943029566, 0.03952847075210458, 0.11226827987756255, -0.13889597487592922 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112294, 0.084179378712684, 0.11664236870396068, 0.0, 0.1468200342221034, 0.07290148043997532, 0.10101525445522092 },
          { 0.0, 0.0, 0.0, 0.49121149998479186, 0.21886638465297908, 0.21384434262392799, -0.2605797108646134, 0.016940773179473304, -0.024786503349591836, 0.037880720420708 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359528, -0.1683587574253683, -0.3499271061118822, 0.0, -0.06776309271789384, -0.14580296087995082, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.4040610178208842, -0.622092633087791, 0.1202675588605911, 0.07905694150420942, 0.07873359887517378, -0.12626906806902655 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268426, 0.34992710611188216, 0.0, 0.033881546358946836, -0.07290148043997557, 0.30304576336566275 },
          { 0.0, 0.0, 0.0, 0.09998110176681574, -0.08417937871268404, 0.5637714487358109, -0.06013377943029572, 0.07341001711105194, -0.185169760317538, 0.1641497884897344 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, 0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052533, -0.14580296087995084, -0.202030508910442 },
          { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268419, 0.11664236870396132, 0.16035674514745446, 0.06776309271789377, 0.03207665139358955, -0.0757614408414161 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719485, 0.0, 0.18070158058105062, 0.0, 0.10101525445522079 },
          { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014799, -0.0777615791359743, -0.32071349029490914, 0.0903507902905255, -0.06415330278717904, 0.05050762722761083 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566363, 0.3110463165438965, 0.0, -0.09035079029052517, 0.1458029608799512, -0.20203050891044172 },
          { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297953, 0.19440394783993506, 0.1603567451474548, -0.15811388300841947, 0.17787961227354074, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678166015, -0.4761904761904763, -1.6495721976846462, 0.0, -0.31943828249997114, -0.4123930494211606, 0.5714285714285698 },
          { 0.0, 0.0, 0.0, 0.6147592613027619, 0.47619047619047594, -0.5498573992282142, 0.56694670951384, 0.1597191412499856, -0.4536323543632768, 0.3571428571428567 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789405, 1.8079567149113942, 0.0, 0.0, -0.5868455973269657, -1.262690680690262, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389457, 1.1664236870396074, -0.33671751485073614, 1.041547612244118, 0.684653196881458, -0.58083771311752, 0.21870444131992506 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.999999999999999, 0.13041013273932608, -0.8417937871268405, 0.9331389496316881, 0.0, 0.11293848786315719, -0.729014804399755, -2.0203050891044194 },
          { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073864, 1.3608276348795436, -0.20044593143431821, 0.6211616832473612, 0.5977921396077994, -0.883883476483185 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871877, 0.4761904761904753, -0.5498573992282163, 0.0, -0.6388765649999408, 0.41239304942116123, -0.14285714285714265 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.1736911946539295, 0.0, 0.0 },
          { 0.0, 3.999999999999995, 0.0, 0.6776309271789406, -0.5248906591678216, 0.0, -2.083095224488238, 0.5868455973269637, -0.10101525445522308, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 },
          { 0.0, 0.0, 4.0, 0.825930840682394, 0.8417937871268399, -1.7885163201274028, 0.0, -1.1293848786315663, 0.7290148043997556, -0.2525381361380524 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112324, 0.08417937871268441, -0.11664236870396069, 0.0, -0.1468200342221037, 0.07290148043997573, -0.10101525445522092 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366903, -0.13468700594029503, 0.09720197391996736, 0.2605797108646139, -0.12987926104263015, 0.09768798378956754, -0.06313453403451338 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359527, -0.16835875742536857, 0.34992710611188216, 0.0, 0.06776309271789394, -0.1458029608799512, 0.3030457633656627 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647918, 0.23570226039551614, -0.27216552697590857, -0.12026755886059132, 0.14682003422210377, -0.2245365597551249, 0.17677669529663703 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179751, -0.08417937871268394, -0.3499271061118825, 0.0, -0.033881546358947, -0.07290148043997534, -0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.0608580619450188, 0.0, 0.21384434262392826, 0.06013377943029566, 0.03952847075210458, 0.11226827987756255, -0.13889597487592922 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112294, 0.084179378712684, 0.11664236870396068, 0.0, 0.1468200342221034, 0.07290148043997532, 0.10101525445522092 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.49121149998479186, 0.21886638465297908, 0.21384434262392799, -0.2605797108646134, 0.016940773179473304, -0.024786503349591836, 0.037880720420708 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359528, -0.1683587574253683, -0.3499271061118822, 0.0, -0.06776309271789384, -0.14580296087995082, -0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007372, -0.4040610178208842, -0.622092633087791, 0.1202675588605911, 0.07905694150420942, 0.07873359887517378, -0.12626906806902655 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179753, -0.08417937871268426, 0.34992710611188216, 0.0, 0.033881546358946836, -0.07290148043997557, 0.30304576336566275 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681574, -0.08417937871268404, 0.5637714487358109, -0.06013377943029572, 0.07341001711105194, -0.185169760317538, 0.1641497884897344 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686873, 0.30304576336566336, 0.3110463165438961, 0.0, -0.09035079029052533, -0.14580296087995084, -0.202030508910442 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112274, 0.08417937871268419, 0.11664236870396132, 0.16035674514745446, 0.06776309271789377, 0.03207665139358955, -0.0757614408414161 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719485, 0.0, 0.18070158058105062, 0.0, 0.10101525445522079 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014799, -0.0777615791359743, -0.32071349029490914, 0.0903507902905255, -0.06415330278717904, 0.05050762722761083 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.38253638936868745, -0.30304576336566363, 0.3110463165438965, 0.0, -0.09035079029052517, 0.1458029608799512, -0.20203050891044172 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.213003216807565, -0.21886638465297953, 0.19440394783993506, 0.1603567451474548, -0.15811388300841947, 0.17787961227354074, -0.12626906806902655 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 4.0, 0.0, 0.0, -0.36885555678166015, -0.4761904761904763, -1.6495721976846462, 0.0, -0.31943828249997114, -0.4123930494211606, 0.5714285714285698 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027619, 0.47619047619047594, -0.5498573992282142, 0.56694670951384, 0.1597191412499856, -0.4536323543632768, 0.3571428571428567 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.6776309271789405, 1.8079567149113942, 0.0, 0.0, -0.5868455973269657, -1.262690680690262, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.054092553389457, 1.1664236870396074, -0.33671751485073614, 1.041547612244118, 0.684653196881458, -0.58083771311752, 0.21870444131992506 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.999999999999999, 0.13041013273932608, -0.8417937871268405, 0.9331389496316881, 0.0, 0.11293848786315719, -0.729014804399755, -2.0203050891044194 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073864, 1.3608276348795436, -0.20044593143431821, 0.6211616832473612, 0.5977921396077994, -0.883883476483185 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809513, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0 };
            static const double coefficients1[10] = { 4.000000000000001, 0.0, 0.0, -1.5983740793871877, 0.4761904761904753, -0.5498573992282163, 0.0, -0.6388765649999408, 0.41239304942116123, -0.14285714285714265 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.1736911946539295, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999995, 0.0, 0.6776309271789406, -0.5248906591678216, 0.0, -2.083095224488238, 0.5868455973269637, -0.10101525445522308, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536826, 0.0, 0.0, 0.0, 1.4580296087995102, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 4.0, 0.825930840682394, 0.8417937871268399, -1.7885163201274028, 0.0, -1.1293848786315663, 0.7290148043997556, -0.2525381361380524 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999996, 0.0, 7.071067811865467, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.2915026221291965, 0.0, -2.993325909419165, 13.662601021279464, 0.0, 0.6110100926607829, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998842, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377584, 0.0, 7.838367176906174, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783185, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119289, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716227, 4.743416490252576, -0.9128709291752792, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999158, 6.123724356957939, 3.5355339059327333, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584945, 0.0, 8.164965809277266, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645636, 5.18459255872625, -1.4966629547095622, 6.831300510639718, -1.05830052442583, 0.30550504633038944, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998338, 2.1908902300206887, 2.529822128134683, 8.082903768654774, 6.260990336999417, -1.8073922282301274, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688803, -5.091168824543128, 3.9191835884530972, 0.0, 9.699484522385697, 4.2000000000000055, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000026, 0.0, -2.828427124746269, 0.0, 0.0, 12.124355652982128, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 3.0) + dof_values[4] * (K[2] * -2.999999999999999) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.9999999999999987) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000027) + dof_values[1] * (K[2] * -3.0000000000000044) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0 + K[2] * -3.0000000000000036) + dof_values[8] * (K[0] * 3.000000000000001 + K[2] * 3.0000000000000053);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999956) + dof_values[2] * (K[0] * -2.9999999999999982) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999964 + K[2] * -2.9999999999999996) + dof_values[5] * (K[0] * 2.999999999999996 + K[2] * 3.0000000000000004);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 3.0) + dof_values[4] * (K[2 + 1] * -2.999999999999999) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.9999999999999987) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000027) + dof_values[1] * (K[2 + 1] * -3.0000000000000044) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0 + K[2 + 1] * -3.0000000000000036) + dof_values[8] * (K[1] * 3.000000000000001 + K[2 + 1] * 3.0000000000000053);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999956) + dof_values[2] * (K[1] * -2.9999999999999982) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999964 + K[2 + 1] * -2.9999999999999996) + dof_values[5] * (K[1] * 2.999999999999996 + K[2 + 1] * 3.0000000000000004);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333355 * sp[33] + 0.3583333333333441 * sp[34] + -0.6083333333333377 * sp[28] + -0.6083333333333277 * sp[31] + 0.3583333333333441 * sp[34] + 0.8583333333333474 * sp[35] + -1.875000000000028 * sp[29] + -0.6083333333333394 * sp[32] + -0.6083333333333377 * sp[28] + -1.875000000000028 * sp[29] + 6.19166666666672 * sp[26] + 1.691666666666662 * sp[27] + -0.6083333333333277 * sp[31] + -0.6083333333333394 * sp[32] + 1.691666666666662 * sp[27] + 0.6333333333333255 * sp[30];
    A[1] = -2.016666666666676 * sp[33] + 1.116666666666661 * sp[34] + -0.61666666666667 * sp[28] + -0.6166666666666837 * sp[31] + 0.2833333333333292 * sp[34] + -0.8000000000000018 * sp[35] + sp[29] + -0.6166666666666825 * sp[32] + 0.216666666666667 * sp[28] + 1.666666666666688 * sp[29] + -3.466666666666701 * sp[26] + 2.78333333333336 * sp[27] + 0.2166666666666572 * sp[31] + 0.2166666666666757 * sp[32] + -0.7166666666666671 * sp[27] + 0.8166666666666601 * sp[30];
    A[2] = -0.03333333333332877 * sp[33] + -0.8916666666666594 * sp[34] + -0.1916666666666706 * sp[28] + -0.1916666666666647 * sp[31] + 0.4416666666666685 * sp[34] + 1.274999999999998 * sp[35] + -0.7916666666666762 * sp[29] + -0.1916666666666615 * sp[32] + -0.1916666666666683 * sp[28] + -0.7916666666666746 * sp[29] + 1.275000000000015 * sp[26] + -0.8916666666666756 * sp[27] + -0.1916666666666701 * sp[31] + -0.1916666666666773 * sp[32] + 0.4416666666666703 * sp[27] + -0.03333333333332722 * sp[30];
    A[3] = -1.591666666666684 * sp[33] + -0.650000000000012 * sp[34] + -2.283333333333352 * sp[28] + -0.650000000000018 * sp[31] + -0.9416666666666762 * sp[34] + -1.295833333333346 * sp[35] + -0.1124999999999993 * sp[29] + -0.4666666666666722 * sp[32] + 0.6916666666666712 * sp[28] + 1.520833333333351 * sp[29] + -1.095833333333336 * sp[26] + -0.2666666666666522 * sp[27] + 0.6916666666666682 * sp[31] + 0.6916666666666731 * sp[32] + 0.6916666666666651 * sp[27] + 0.5083333333333415 * sp[30];
    A[4] = -0.06666666666665866 * sp[33] + -0.5333333333333217 * sp[34] + -0.09999999999999276 * sp[28] + -0.5333333333333249 * sp[31] + 0.8833333333333372 * sp[34] + 1.675000000000001 * sp[35] + 0.1416666666666643 * sp[29] + 0.9333333333333196 * sp[32] + -0.3833333333333358 * sp[28] + -0.9583333333333428 * sp[29] + 0.441666666666669 * sp[26] + -0.1333333333333357 * sp[27] + -0.3833333333333403 * sp[31] + -0.3833333333333455 * sp[32] + -0.3833333333333371 * sp[27] + -0.600000000000009 * sp[30];
    A[5] = -1.008333333333336 * sp[33] + 1.183333333333329 * sp[34] + -2.116666666666676 * sp[28] + 1.183333333333329 * sp[31] + 0.1416666666666654 * sp[34] + -0.8374999999999975 * sp[35] + 0.5125000000000003 * sp[29] + -0.4666666666666585 * sp[32] + 0.1083333333333318 * sp[28] + 1.145833333333344 * sp[29] + -0.6375000000000116 * sp[26] + 0.4000000000000108 * sp[27] + 0.1083333333333278 * sp[31] + 0.1083333333333416 * sp[32] + 0.1083333333333229 * sp[27] + 0.09166666666667866 * sp[30];
    A[6] = -1.091666666666675 * sp[33] + -1.108333333333343 * sp[34] + -1.108333333333342 * sp[28] + -1.108333333333338 * sp[31] + -0.7333333333333457 * sp[34] + -0.3624999999999964 * sp[35] + -1.479166666666687 * sp[29] + -1.108333333333342 * sp[32] + 2.133333333333354 * sp[28] + 1.154166666666659 * sp[29] + 3.170833333333356 * sp[26] + 2.191666666666669 * sp[27] + 1.149999999999997 * sp[31] + 1.116666666666659 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333329 * sp[30];
    A[7] = 2.600000000000015 * sp[33] + 1.216666666666668 * sp[34] + 1.216666666666674 * sp[28] + 1.216666666666664 * sp[31] + 1.466666666666685 * sp[34] + 0.3083333333333419 * sp[35] + 2.375000000000033 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333369 * sp[28] + -1.05833333333333 * sp[29] + -7.258333333333391 * sp[26] + -3.383333333333329 * sp[27] + -2.13333333333332 * sp[31] + -0.8999999999999915 * sp[32] + -2.133333333333326 * sp[27] + -1.266666666666652 * sp[30];
    A[8] = -1.508333333333342 * sp[33] + 0.3083333333333495 * sp[34] + 0.3083333333333361 * sp[28] + 0.3083333333333491 * sp[31] + -0.7333333333333413 * sp[34] + 0.7625000000000099 * sp[35] + -1.187500000000015 * sp[29] + 0.3083333333333433 * sp[32] + 2.800000000000018 * sp[28] + -2.887500000000019 * sp[29] + 4.295833333333371 * sp[26] + -1.391666666666691 * sp[27] + 0.9833333333333238 * sp[31] + -0.7166666666666586 * sp[32] + 0.9833333333333308 * sp[27] + -0.4083333333333333 * sp[30];
    A[9] = 1.649915822768659 * sp[33] + 0.4714045207910438 * sp[34] + -5.185449728701379 * sp[28] + -5.185449728701393 * sp[31] + 3.064129385141734 * sp[34] + 1.767766952966339 * sp[35] + -3.889087296526076 * sp[29] + -5.185449728701429 * sp[32] + -1.649915822768632 * sp[28] + 5.067598598503611 * sp[29] + 10.72445284799603 * sp[26] + 17.44196726926825 * sp[27] + -1.649915822768635 * sp[31] + -0.2357022603955659 * sp[32] + 4.006938426723748 * sp[27] + 5.892556509887839 * sp[30];
    A[10] = 10.96965511460297 * sp[33] + 0.7216878364869957 * sp[34] + -10.53664241271075 * sp[28] + -10.53664241271076 * sp[31] + 0.1443375672973231 * sp[34] + -1.732050807568894 * sp[35] + -8.660254037844515 * sp[29] + -10.5366424127108 * sp[32] + 0.7216878364870799 * sp[28] + 11.54700538379251 * sp[29] + 18.47520861406813 * sp[26] + 29.30052616137361 * sp[27] + 0.7216878364870614 * sp[31] + 5.051814855409161 * sp[32] + 7.649891066762519 * sp[27] + 10.96965511460281 * sp[30];
    A[11] = -6.833333333333353 * sp[33] + 1.583333333333382 * sp[34] + 0.08333333333331305 * sp[28] + 0.08333333333333215 * sp[31] + 2.416666666666659 * sp[34] + 3.749999999999958 * sp[35] + -1.249999999999998 * sp[29] + 0.08333333333338389 * sp[32] + 0.08333333333332088 * sp[28] + -4.916666666666665 * sp[29] + -5.91666666666671 * sp[26] + -10.91666666666672 * sp[27] + 0.08333333333329063 * sp[31] + 0.5833333333333584 * sp[32] + -0.916666666666632 * sp[27] + -1.833333333333267 * sp[30];
    A[12] = 5.89255650988789 * sp[33] + -1.649915822768628 * sp[34] + 16.73486048808173 * sp[28] + 4.006938426723815 * sp[31] + -3.299831645537225 * sp[34] + -2.474873734152917 * sp[35] + 3.181980515339537 * sp[29] + 4.006938426723851 * sp[32] + 0.4714045207910476 * sp[28] + -2.003469213361912 * sp[29] + -7.660323462854306 * sp[26] + -10.1351971970073 * sp[27] + 0.4714045207910823 * sp[31] + 0.4714045207910431 * sp[32] + -5.185449728701299 * sp[27] + -4.006938426723782 * sp[30];
    A[13] = -16.88749537379672 * sp[33] + -7.361215932167807 * sp[34] + -7.361215932167788 * sp[28] + 3.897114317029946 * sp[31] + -5.196152422706707 * sp[34] + -6.278684177437302 * sp[35] + 4.979646071760513 * sp[29] + 3.897114317029911 * sp[32] + 5.19615242270667 * sp[28] + 11.9078493020362 * sp[29] + -21.8671414455572 * sp[26] + -15.15544456622755 * sp[27] + 5.196152422706616 * sp[31] + 5.196152422706657 * sp[32] + -1.732050807568872 * sp[27] + -3.897114317029861 * sp[30];
    A[14] = 10.41666666666666 * sp[33] + -2.916666666666698 * sp[34] + 10.08333333333337 * sp[28] + -1.416666666666664 * sp[31] + -5.833333333333339 * sp[34] + -4.375000000000002 * sp[35] + -2.874999999999999 * sp[29] + -1.416666666666789 * sp[32] + 0.8333333333333677 * sp[28] + -3.541666666666713 * sp[29] + 7.958333333333433 * sp[26] + 3.58333333333334 * sp[27] + 0.8333333333334234 * sp[31] + 0.8333333333333535 * sp[32] + 1.833333333333369 * sp[27] + 2.916666666666623 * sp[30];
    A[15] = -2.016666666666676 * sp[33] + 0.2833333333333292 * sp[34] + 0.216666666666667 * sp[28] + 0.2166666666666572 * sp[31] + 1.116666666666661 * sp[34] + -0.8000000000000018 * sp[35] + 1.666666666666688 * sp[29] + 0.2166666666666757 * sp[32] + -0.61666666666667 * sp[28] + sp[29] + -3.466666666666701 * sp[26] + -0.7166666666666671 * sp[27] + -0.6166666666666837 * sp[31] + -0.6166666666666825 * sp[32] + 2.78333333333336 * sp[27] + 0.8166666666666601 * sp[30];
    A[16] = 2.533333333333343 * sp[33] + -1.733333333333329 * sp[34] + 0.7333333333333384 * sp[28] + 0.7333333333333553 * sp[31] + -1.733333333333329 * sp[34] + 2.766666666666649 * sp[35] + -2.166666666666674 * sp[29] + 0.7333333333333426 * sp[32] + 0.7333333333333384 * sp[28] + -2.166666666666674 * sp[29] + 2.766666666666691 * sp[26] + -1.733333333333344 * sp[27] + 0.7333333333333553 * sp[31] + 0.7333333333333426 * sp[32] + -1.733333333333344 * sp[27] + 2.533333333333352 * sp[30];
    A[17] = 0.8166666666666668 * sp[33] + 2.783333333333335 * sp[34] + -0.6166666666666721 * sp[28] + -0.6166666666666767 * sp[31] + -0.7166666666666646 * sp[34] + -3.466666666666652 * sp[35] + sp[29] + -0.6166666666666748 * sp[32] + 0.2166666666666681 * sp[28] + 1.666666666666673 * sp[29] + -0.8000000000000103 * sp[26] + 1.116666666666669 * sp[27] + 0.2166666666666737 * sp[31] + 0.2166666666666778 * sp[32] + 0.283333333333334 * sp[27] + -2.01666666666668 * sp[30];
    A[18] = -0.06666666666666518 * sp[33] + -0.9499999999999984 * sp[34] + 0.3166666666666725 * sp[28] + -0.9499999999999913 * sp[31] + 0.4666666666666699 * sp[34] + 1.258333333333337 * sp[35] + -0.1083333333333425 * sp[29] + 0.6833333333333304 * sp[32] + 0.03333333333333188 * sp[28] + -0.7083333333333431 * sp[29] + 0.8583333333333358 * sp[26] + 0.1166666666666584 * sp[27] + 0.0333333333333313 * sp[31] + 0.03333333333333693 * sp[32] + 0.03333333333331881 * sp[27] + -0.183333333333339 * sp[30];
    A[19] = 1.633333333333336 * sp[33] + 3.066666666666668 * sp[34] + 1.199999999999994 * sp[28] + 3.066666666666663 * sp[31] + -1.433333333333331 * sp[34] + -3.683333333333323 * sp[35] + -0.2833333333333243 * sp[29] + -2.533333333333301 * sp[32] + 0.4333333333333368 * sp[28] + 1.583333333333341 * sp[29] + -0.2166666666666668 * sp[26] + 0.9333333333333413 * sp[27] + 0.4333333333333484 * sp[31] + 0.4333333333333464 * sp[32] + 0.4333333333333523 * sp[27] + 1.200000000000032 * sp[30];
    A[20] = 1.26666666666667 * sp[33] + -2.116666666666664 * sp[34] + 2.483333333333342 * sp[28] + -2.116666666666668 * sp[31] + -0.8666666666666641 * sp[34] + 3.008333333333314 * sp[35] + -2.024999999999999 * sp[29] + 1.849999999999973 * sp[32] + 0.3666666666666694 * sp[28] + -1.958333333333338 * sp[29] + 1.275000000000012 * sp[26] + -1.050000000000006 * sp[27] + 0.3666666666666769 * sp[31] + 0.3666666666666666 * sp[32] + 0.3666666666666801 * sp[27] + -1.016666666666673 * sp[30];
    A[21] = 0.1833333333333387 * sp[33] + -0.03333333333332775 * sp[34] + -0.0333333333333363 * sp[28] + -0.03333333333333688 * sp[31] + -0.1166666666666594 * sp[34] + -0.8583333333333442 * sp[35] + 0.7083333333333506 * sp[29] + -0.03333333333332966 * sp[32] + -0.6833333333333468 * sp[28] + 0.1083333333333328 * sp[29] + -1.258333333333349 * sp[26] + -0.4666666666666696 * sp[27] + 0.9500000000000024 * sp[31] + -0.3166666666666937 * sp[32] + 0.9500000000000093 * sp[27] + 0.06666666666665713 * sp[30];
    A[22] = -1.200000000000008 * sp[33] + -0.433333333333328 * sp[34] + -0.4333333333333335 * sp[28] + -0.4333333333333259 * sp[31] + -0.9333333333333422 * sp[34] + 0.2166666666666532 * sp[35] + -1.583333333333361 * sp[29] + -0.4333333333333472 * sp[32] + 2.533333333333358 * sp[28] + 0.2833333333333361 * sp[29] + 3.683333333333371 * sp[26] + 1.433333333333335 * sp[27] + -3.066666666666682 * sp[31] + -1.199999999999987 * sp[32] + -3.066666666666696 * sp[27] + -1.633333333333324 * sp[30];
    A[23] = 1.016666666666669 * sp[33] + -0.366666666666692 * sp[34] + -0.3666666666666703 * sp[28] + -0.3666666666666862 * sp[31] + 1.050000000000003 * sp[34] + -1.275000000000003 * sp[35] + 1.958333333333345 * sp[29] + -0.3666666666666694 * sp[32] + -1.850000000000012 * sp[28] + 2.025000000000007 * sp[29] + -3.008333333333361 * sp[26] + 0.8666666666666758 * sp[27] + 2.11666666666668 * sp[31] + -2.483333333333348 * sp[32] + 2.116666666666683 * sp[27] + -1.266666666666683 * sp[30];
    A[24] = 3.771236166328261 * sp[33] + 6.128258770283456 * sp[34] + 3.299831645537238 * sp[28] + 3.299831645537267 * sp[31] + -3.771236166328256 * sp[34] + 1.178511301977638 * sp[35] + -1.649915822768554 * sp[29] + 3.299831645537287 * sp[32] + 0.9428090415820729 * sp[28] + -5.421151989096858 * sp[29] + -2.59272486435071 * sp[26] + -8.95668589502964 * sp[27] + 0.9428090415820962 * sp[31] + 12.25651754056691 * sp[32] + 3.771236166328307 * sp[27] + 11.78511301977583 * sp[30];
    A[25] = -8.9489291724392 * sp[33] + -1.443375672973971 * sp[34] + 3.752776749732583 * sp[28] + 3.752776749732635 * sp[31] + -3.175426480542776 * sp[34] + 2.0207259421637 * sp[35] + -1.443375672973948 * sp[29] + 3.752776749732649 * sp[32] + 1.443375672974011 * sp[28] + -7.216878364870326 * sp[29] + -3.752776749732633 * sp[26] + -12.41303078757702 * sp[27] + 1.443375672973977 * sp[31] + 10.10362971081835 * sp[32] + 4.907477288111897 * sp[27] + 14.14508159514586 * sp[30];
    A[26] = 11.16666666666669 * sp[33] + 1.833333333333281 * sp[34] + -5.166666666666704 * sp[28] + -5.166666666666719 * sp[31] + -8.166666666666647 * sp[34] + -16.66666666666659 * sp[35] + 3.333333333333325 * sp[29] + -5.166666666666748 * sp[32] + 3.166666666666695 * sp[28] + 10.66666666666666 * sp[29] + 2.666666666666691 * sp[26] + 10.16666666666669 * sp[27] + 3.166666666666758 * sp[31] + -7.833333333333399 * sp[32] + -4.833333333333407 * sp[27] + -17.16666666666675 * sp[30];
    A[27] = -11.78511301977582 * sp[33] + -3.771236166328268 * sp[34] + -12.25651754056686 * sp[28] + -0.942809041582066 * sp[31] + 8.956685895029585 * sp[34] + 2.592724864350691 * sp[35] + 5.421151989096812 * sp[29] + -0.9428090415820995 * sp[32] + -3.299831645537249 * sp[28] + 1.649915822768607 * sp[29] + -1.178511301977577 * sp[26] + 3.771236166328305 * sp[27] + -3.299831645537319 * sp[31] + -3.299831645537283 * sp[32] + -6.128258770283507 * sp[27] + -3.771236166328316 * sp[30];
    A[28] = 7.794228634060024 * sp[33] + 1.732050807568895 * sp[34] + 1.73205080756889 * sp[28] + -3.464101615137761 * sp[31] + -2.598076211353306 * sp[34] + -0.4330127018921406 * sp[35] + -5.629165124598799 * sp[29] + -3.464101615137675 * sp[32] + 2.598076211353332 * sp[28] + -2.165063509461177 * sp[29] + 13.42339375865889 * sp[26] + 8.660254037844338 * sp[27] + 2.598076211353385 * sp[31] + 2.598076211353414 * sp[32] + -0.8660254037845787 * sp[27] + -5.196152422706558 * sp[30];
    A[29] = -20.83333333333339 * sp[33] + -6.666666666666689 * sp[34] + -12.66666666666668 * sp[28] + 0.3333333333333488 * sp[31] + 15.8333333333333 * sp[34] + 4.583333333333361 * sp[35] + 11.5833333333333 * sp[29] + 0.3333333333335808 * sp[32] + -5.833333333333382 * sp[28] + 2.916666666666662 * sp[29] + -10.08333333333342 * sp[26] + -1.333333333333362 * sp[27] + -5.833333333333505 * sp[31] + -5.833333333333442 * sp[32] + 2.166666666666594 * sp[27] + 13.33333333333328 * sp[30];
    A[30] = -0.03333333333332877 * sp[33] + 0.4416666666666685 * sp[34] + -0.1916666666666683 * sp[28] + -0.1916666666666701 * sp[31] + -0.8916666666666594 * sp[34] + 1.274999999999998 * sp[35] + -0.7916666666666746 * sp[29] + -0.1916666666666773 * sp[32] + -0.1916666666666706 * sp[28] + -0.7916666666666762 * sp[29] + 1.275000000000015 * sp[26] + 0.4416666666666703 * sp[27] + -0.1916666666666647 * sp[31] + -0.1916666666666615 * sp[32] + -0.8916666666666756 * sp[27] + -0.03333333333332722 * sp[30];
    A[31] = 0.8166666666666668 * sp[33] + -0.7166666666666646 * sp[34] + 0.2166666666666681 * sp[28] + 0.2166666666666737 * sp[31] + 2.783333333333335 * sp[34] + -3.466666666666652 * sp[35] + 1.666666666666673 * sp[29] + 0.2166666666666778 * sp[32] + -0.6166666666666721 * sp[28] + sp[29] + -0.8000000000000103 * sp[26] + 0.283333333333334 * sp[27] + -0.6166666666666767 * sp[31] + -0.6166666666666748 * sp[32] + 1.116666666666669 * sp[27] + -2.01666666666668 * sp[30];
    A[32] = 0.6333333333333344 * sp[33] + 1.691666666666667 * sp[34] + -0.6083333333333382 * sp[28] + -0.6083333333333383 * sp[31] + 1.691666666666667 * sp[34] + 6.191666666666659 * sp[35] + -1.875000000000011 * sp[29] + -0.6083333333333375 * sp[32] + -0.6083333333333382 * sp[28] + -1.875000000000011 * sp[29] + 0.8583333333333434 * sp[26] + 0.3583333333333373 * sp[27] + -0.6083333333333383 * sp[31] + -0.6083333333333375 * sp[32] + 0.3583333333333373 * sp[27] + 2.633333333333349 * sp[30];
    A[33] = -1.008333333333339 * sp[33] + -1.150000000000003 * sp[34] + -1.116666666666668 * sp[28] + -1.15 * sp[31] + -2.191666666666675 * sp[34] + -3.170833333333334 * sp[35] + -1.154166666666669 * sp[29] + -2.133333333333332 * sp[32] + 1.108333333333344 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000087 * sp[26] + 0.7333333333333434 * sp[27] + 1.108333333333341 * sp[31] + 1.108333333333335 * sp[32] + 1.108333333333347 * sp[27] + 1.091666666666671 * sp[30];
    A[34] = 1.26666666666667 * sp[33] + 2.133333333333335 * sp[34] + 0.8999999999999962 * sp[28] + 2.133333333333328 * sp[31] + 3.383333333333338 * sp[34] + 7.258333333333328 * sp[35] + 1.058333333333324 * sp[29] + 4.933333333333313 * sp[32] + -1.216666666666677 * sp[28] + -2.375000000000013 * sp[29] + -0.3083333333333367 * sp[26] + -1.466666666666676 * sp[27] + -1.216666666666678 * sp[31] + -1.216666666666673 * sp[32] + -1.216666666666676 * sp[27] + -2.600000000000018 * sp[30];
    A[35] = 0.4083333333333337 * sp[33] + -0.9833333333333313 * sp[34] + 0.716666666666667 * sp[28] + -0.9833333333333336 * sp[31] + 1.391666666666667 * sp[34] + -4.29583333333332 * sp[35] + 2.887500000000002 * sp[29] + -2.79999999999999 * sp[32] + -0.3083333333333367 * sp[28] + 1.187500000000007 * sp[29] + -0.7625000000000071 * sp[26] + 0.7333333333333431 * sp[27] + -0.3083333333333387 * sp[31] + -0.3083333333333375 * sp[32] + -0.3083333333333393 * sp[27] + 1.508333333333338 * sp[30];
    A[36] = -0.5083333333333316 * sp[33] + -0.6916666666666644 * sp[34] + -0.6916666666666722 * sp[28] + -0.6916666666666702 * sp[31] + 0.2666666666666673 * sp[34] + 1.095833333333336 * sp[35] + -1.520833333333347 * sp[29] + -0.6916666666666721 * sp[32] + 0.466666666666674 * sp[28] + 0.1125000000000044 * sp[29] + 1.295833333333346 * sp[26] + 0.9416666666666742 * sp[27] + 0.6500000000000005 * sp[31] + 2.283333333333357 * sp[32] + 0.650000000000001 * sp[27] + 1.591666666666681 * sp[30];
    A[37] = 0.5999999999999991 * sp[33] + 0.3833333333333365 * sp[34] + 0.3833333333333359 * sp[28] + 0.3833333333333362 * sp[31] + 0.1333333333333369 * sp[34] + -0.4416666666666494 * sp[35] + 0.9583333333333445 * sp[29] + 0.3833333333333449 * sp[32] + -0.9333333333333471 * sp[28] + -0.1416666666666738 * sp[29] + -1.675000000000017 * sp[26] + -0.8833333333333391 * sp[27] + 0.5333333333333369 * sp[31] + 0.09999999999999121 * sp[32] + 0.5333333333333441 * sp[27] + 0.06666666666665821 * sp[30];
    A[38] = -0.09166666666666883 * sp[33] + -0.1083333333333436 * sp[34] + -0.1083333333333339 * sp[28] + -0.1083333333333392 * sp[31] + -0.4000000000000071 * sp[34] + 0.6374999999999785 * sp[35] + -1.145833333333339 * sp[29] + -0.1083333333333458 * sp[32] + 0.4666666666666748 * sp[28] + -0.5124999999999963 * sp[29] + 0.8375000000000103 * sp[26] + -0.1416666666666671 * sp[27] + -1.183333333333336 * sp[31] + 2.11666666666668 * sp[32] + -1.18333333333334 * sp[27] + 1.008333333333344 * sp[30];
    A[39] = 4.006938426723791 * sp[33] + 5.185449728701376 * sp[34] + -0.4714045207910351 * sp[28] + -0.4714045207910191 * sp[31] + 10.13519719700722 * sp[34] + 7.660323462854288 * sp[35] + 2.00346921336187 * sp[29] + -0.4714045207910296 * sp[32] + -4.006938426723814 * sp[28] + -3.181980515339505 * sp[29] + 2.474873734152936 * sp[26] + 3.299831645537241 * sp[27] + -4.00693842672381 * sp[31] + -16.73486048808172 * sp[32] + 1.649915822768592 * sp[27] + -5.89255650988791 * sp[30];
    A[40] = -0.5773502691895829 * sp[33] + -0.7216878364869734 * sp[34] + -3.31976404784037 * sp[28] + -3.319764047840335 * sp[31] + 4.474464586219616 * sp[34] + 4.04145188432746 * sp[35] + -2.886751345948182 * sp[29] + -3.319764047840335 * sp[32] + -0.72168783648705 * sp[28] + 6.928203230275567 * sp[26] + 7.649891066762587 * sp[27] + -0.7216878364870478 * sp[31] + -5.0518148554092 * sp[32] + 6.206515393788464 * sp[27] + -0.5773502691896129 * sp[30];
    A[41] = 4.833333333333333 * sp[33] + 2.416666666666647 * sp[34] + -4.083333333333367 * sp[28] + -4.083333333333365 * sp[31] + 14.91666666666666 * sp[34] + 22.91666666666659 * sp[35] + -12.08333333333339 * sp[29] + -4.083333333333343 * sp[32] + -4.083333333333364 * sp[28] + -5.749999999999989 * sp[29] + 3.250000000000036 * sp[26] + 1.583333333333357 * sp[27] + -4.083333333333376 * sp[31] + 11.41666666666674 * sp[32] + 4.916666666666729 * sp[27] + 19.83333333333344 * sp[30];
    A[42] = -5.892556509887906 * sp[33] + -4.00693842672378 * sp[34] + 0.2357022603955463 * sp[28] + 1.649915822768631 * sp[31] + -17.44196726926819 * sp[34] + -10.724452847996 * sp[35] + -5.067598598503528 * sp[29] + 1.649915822768641 * sp[32] + 5.185449728701395 * sp[28] + 3.88908729652603 * sp[29] + -1.767766952966403 * sp[26] + -3.064129385141758 * sp[27] + 5.185449728701407 * sp[31] + 5.185449728701389 * sp[32] + -0.4714045207910229 * sp[27] + -1.649915822768606 * sp[30];
    A[43] = -3.897114317029999 * sp[33] + -3.031088913245559 * sp[34] + -3.031088913245549 * sp[28] + -0.4330127018922432 * sp[31] + -5.196152422706646 * sp[34] + -4.11362066797612 * sp[35] + -1.515544456622838 * sp[29] + -0.4330127018922776 * sp[32] + 5.196152422706676 * sp[28] + 5.412658773652808 * sp[29] + -2.3815698604072 * sp[26] + -2.165063509461061 * sp[27] + 5.196152422706643 * sp[31] + 5.196152422706614 * sp[32] + -1.7320508075688 * sp[27] + 0.4330127018921672 * sp[30];
    A[44] = -10.41666666666668 * sp[33] + -7.083333333333352 * sp[34] + -4.083333333333309 * sp[28] + -0.5833333333333179 * sp[31] + -30.83333333333335 * sp[34] + -18.95833333333337 * sp[35] + -12.45833333333329 * sp[29] + -0.5833333333334191 * sp[32] + 9.16666666666675 * sp[28] + 6.875000000000032 * sp[29] + 3.375000000000036 * sp[26] + 1.083333333333331 * sp[27] + 9.166666666666771 * sp[31] + 9.166666666666741 * sp[32] + 0.1666666666666887 * sp[27] + -12.91666666666669 * sp[30];
    A[45] = -1.591666666666684 * sp[33] + -0.9416666666666762 * sp[34] + 0.6916666666666712 * sp[28] + 0.6916666666666682 * sp[31] + -0.650000000000012 * sp[34] + -1.295833333333346 * sp[35] + 1.520833333333351 * sp[29] + 0.6916666666666731 * sp[32] + -2.283333333333352 * sp[28] + -0.1124999999999993 * sp[29] + -1.095833333333336 * sp[26] + 0.6916666666666651 * sp[27] + -0.650000000000018 * sp[31] + -0.4666666666666722 * sp[32] + -0.2666666666666522 * sp[27] + 0.5083333333333415 * sp[30];
    A[46] = -0.06666666666666518 * sp[33] + 0.4666666666666699 * sp[34] + 0.03333333333333188 * sp[28] + 0.0333333333333313 * sp[31] + -0.9499999999999984 * sp[34] + 1.258333333333337 * sp[35] + -0.7083333333333431 * sp[29] + 0.03333333333333693 * sp[32] + 0.3166666666666725 * sp[28] + -0.1083333333333425 * sp[29] + 0.8583333333333358 * sp[26] + 0.03333333333331881 * sp[27] + -0.9499999999999913 * sp[31] + 0.6833333333333304 * sp[32] + 0.1166666666666584 * sp[27] + -0.183333333333339 * sp[30];
    A[47] = -1.008333333333339 * sp[33] + -2.191666666666675 * sp[34] + 1.108333333333344 * sp[28] + 1.108333333333341 * sp[31] + -1.150000000000003 * sp[34] + -3.170833333333334 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333335 * sp[32] + -1.116666666666668 * sp[28] + -1.154166666666669 * sp[29] + 0.3625000000000087 * sp[26] + 1.108333333333347 * sp[27] + -1.15 * sp[31] + -2.133333333333332 * sp[32] + 0.7333333333333434 * sp[27] + 1.091666666666671 * sp[30];
    A[48] = 2.633333333333352 * sp[33] + 2.275000000000012 * sp[34] + 3.241666666666682 * sp[28] + 2.275000000000014 * sp[31] + 2.275000000000012 * sp[34] + 2.775000000000008 * sp[35] + 1.008333333333342 * sp[29] + 1.50833333333334 * sp[32] + 3.241666666666682 * sp[28] + 1.008333333333342 * sp[29] + 10.04166666666666 * sp[26] + 5.508333333333333 * sp[27] + 2.275000000000014 * sp[31] + 1.50833333333334 * sp[32] + 5.508333333333333 * sp[27] + 3.683333333333331 * sp[30];
    A[49] = -2.016666666666679 * sp[33] + -3.133333333333347 * sp[34] + -1.400000000000002 * sp[28] + -3.133333333333337 * sp[31] + -2.300000000000006 * sp[34] + -4.216666666666669 * sp[35] + -0.6833333333333311 * sp[29] + -2.599999999999992 * sp[32] + -2.233333333333343 * sp[28] + -1.683333333333344 * sp[29] + -5.08333333333332 * sp[26] + -7.933333333333318 * sp[27] + -2.300000000000004 * sp[31] + -2.766666666666668 * sp[32] + -3.433333333333321 * sp[27] + -5.866666666666649 * sp[30];
    A[50] = -0.03333333333333428 * sp[33] + 0.8583333333333365 * sp[34] + 0.1583333333333346 * sp[28] + 0.8583333333333407 * sp[31] + -0.4750000000000005 * sp[34] + 1.691666666666666 * sp[35] + -1.075000000000001 * sp[29] + 1.09166666666667 * sp[32] + 0.1583333333333356 * sp[28] + 0.2583333333333276 * sp[29] + 1.625000000000003 * sp[26] + 2.424999999999991 * sp[27] + -0.4749999999999961 * sp[31] + 1.091666666666663 * sp[32] + -0.2416666666666614 * sp[27] + 2.183333333333327 * sp[30];
    A[51] = 1.508333333333336 * sp[33] + 1.816666666666671 * sp[34] + 1.81666666666668 * sp[28] + 1.816666666666675 * sp[31] + 0.7750000000000072 * sp[34] + 0.3208333333333345 * sp[35] + 2.270833333333349 * sp[29] + 1.816666666666675 * sp[32] + 4.308333333333319 * sp[28] + 7.504166666666657 * sp[29] + 0.3208333333333446 * sp[26] + 1.816666666666672 * sp[27] + 2.591666666666665 * sp[31] + 4.308333333333326 * sp[32] + 0.7750000000000161 * sp[27] + 1.508333333333341 * sp[30];
    A[52] = -2.600000000000007 * sp[33] + -1.38333333333334 * sp[34] + -1.38333333333334 * sp[28] + -1.383333333333335 * sp[31] + -1.133333333333349 * sp[34] + -0.2250000000000117 * sp[35] + -2.291666666666688 * sp[29] + -1.383333333333342 * sp[32] + -7.533333333333313 * sp[28] + -5.258333333333323 * sp[29] + 0.941666666666667 * sp[26] + -1.383333333333327 * sp[27] + -3.933333333333342 * sp[31] + -2.866666666666672 * sp[32] + 0.0333333333333149 * sp[27] + -1.016666666666675 * sp[30];
    A[53] = 1.091666666666675 * sp[33] + -0.016666666666659 * sp[34] + -0.01666666666666661 * sp[28] + -0.01666666666666641 * sp[31] + 0.3583333333333452 * sp[34] + -0.3874999999999941 * sp[35] + 0.7291666666666772 * sp[29] + -0.0166666666666677 * sp[32] + 3.225 * sp[28] + 0.9625000000000112 * sp[29] + -1.05416666666667 * sp[26] + -0.01666666666665874 * sp[27] + 1.34166666666668 * sp[31] + 0.5583333333333422 * sp[32] + -0.3083333333333239 * sp[27] + 0.09166666666667309 * sp[30];
    A[54] = -7.542472332656575 * sp[33] + -8.720983634634146 * sp[34] + 4.006938426723785 * sp[28] + 4.00693842672377 * sp[31] + -7.77817459305207 * sp[34] + -8.249579113843069 * sp[35] + 4.478342947514835 * sp[29] + 4.006938426723806 * sp[32] + -8.720983634634141 * sp[28] + -12.96362432175344 * sp[29] + -0.2357022603955148 * sp[26] + 4.00693842672371 * sp[27] + -7.778174593052062 * sp[31] + -11.07800623858926 * sp[32] + 0.2357022603955428 * sp[27] + 2.357022603955167 * sp[30];
    A[55] = -5.917840259193766 * sp[33] + 0.7216878364869701 * sp[34] + 11.9800180856848 * sp[28] + 11.98001808568476 * sp[31] + -0.8660254037844752 * sp[34] + -2.23723229310984 * sp[35] + 13.35122497501018 * sp[29] + 11.9800180856848 * sp[32] + -11.83568051838749 * sp[28] + 18.25870226312177 * sp[29] + 2.670244995002077 * sp[26] + 11.98001808568467 * sp[27] + -0.8660254037845805 * sp[31] + 10.96965511460278 * sp[32] + 4.04145188432746 * sp[27] + 8.804591605141816 * sp[30];
    A[56] = -3.583333333333337 * sp[33] + -4.916666666666659 * sp[34] + 6.583333333333405 * sp[28] + 6.583333333333393 * sp[31] + -6.999999999999996 * sp[34] + -7.708333333333282 * sp[35] + 7.291666666666704 * sp[29] + 6.583333333333334 * sp[32] + -2.666666666666635 * sp[28] + 4.458333333333303 * sp[29] + 5.45833333333341 * sp[26] + 6.583333333333442 * sp[27] + -6.999999999999959 * sp[31] + 2.166666666666648 * sp[32] + 6.166666666666707 * sp[27] + 6.916666666666687 * sp[30];
    A[57] = 5.892556509887934 * sp[33] + 7.542472332656537 * sp[34] + -10.84230397819382 * sp[28] + -5.185449728701407 * sp[31] + 9.192388155425137 * sp[34] + 8.367430244040808 * sp[35] + -4.360491817317126 * sp[29] + -5.185449728701429 * sp[32] + 5.421151989096883 * sp[28] + 5.067598598503643 * sp[29] + -18.9740319618391 * sp[26] + -5.185449728701351 * sp[27] + 9.192388155425107 * sp[31] + 5.892556509887909 * sp[32] + -6.835365551470073 * sp[27] + -4.006938426723819 * sp[30];
    A[58] = 16.88749537379668 * sp[33] + 9.526279441628903 * sp[34] + 9.526279441628887 * sp[28] + -1.732050807568816 * sp[31] + 11.69134295109 * sp[34] + 10.60881119635947 * sp[35] + -0.649519052838297 * sp[29] + -1.732050807568815 * sp[32] + 22.0836477965033 * sp[28] + 2.814582562299452 * sp[29] + 36.58957330989249 * sp[26] + -1.732050807568839 * sp[27] + 11.69134295109002 * sp[31] + 3.897114317030031 * sp[32] + 19.48557158514985 * sp[27] + 0.4330127018922303 * sp[30];
    A[59] = 10.41666666666673 * sp[33] + 13.33333333333338 * sp[34] + 0.3333333333332962 * sp[28] + 1.833333333333302 * sp[31] + 16.25000000000003 * sp[34] + 14.79166666666666 * sp[35] + 3.291666666666655 * sp[29] + 1.833333333333351 * sp[32] + 9.583333333333346 * sp[28] + 8.958333333333419 * sp[29] + 7.458333333333224 * sp[26] + 1.83333333333326 * sp[27] + 16.24999999999997 * sp[31] + 10.41666666666668 * sp[32] + 9.41666666666659 * sp[27] + 2.916666666666641 * sp[30];
    A[60] = -0.06666666666665866 * sp[33] + 0.8833333333333372 * sp[34] + -0.3833333333333358 * sp[28] + -0.3833333333333403 * sp[31] + -0.5333333333333217 * sp[34] + 1.675000000000001 * sp[35] + -0.9583333333333428 * sp[29] + -0.3833333333333455 * sp[32] + -0.09999999999999276 * sp[28] + 0.1416666666666643 * sp[29] + 0.441666666666669 * sp[26] + -0.3833333333333371 * sp[27] + -0.5333333333333249 * sp[31] + 0.9333333333333196 * sp[32] + -0.1333333333333357 * sp[27] + -0.600000000000009 * sp[30];
    A[61] = 1.633333333333336 * sp[33] + -1.433333333333331 * sp[34] + 0.4333333333333368 * sp[28] + 0.4333333333333484 * sp[31] + 3.066666666666668 * sp[34] + -3.683333333333323 * sp[35] + 1.583333333333341 * sp[29] + 0.4333333333333464 * sp[32] + 1.199999999999994 * sp[28] + -0.2833333333333243 * sp[29] + -0.2166666666666668 * sp[26] + 0.4333333333333523 * sp[27] + 3.066666666666663 * sp[31] + -2.533333333333301 * sp[32] + 0.9333333333333413 * sp[27] + 1.200000000000032 * sp[30];
    A[62] = 1.26666666666667 * sp[33] + 3.383333333333338 * sp[34] + -1.216666666666677 * sp[28] + -1.216666666666678 * sp[31] + 2.133333333333335 * sp[34] + 7.258333333333328 * sp[35] + -2.375000000000013 * sp[29] + -1.216666666666673 * sp[32] + 0.8999999999999962 * sp[28] + 1.058333333333324 * sp[29] + -0.3083333333333367 * sp[26] + -1.216666666666676 * sp[27] + 2.133333333333328 * sp[31] + 4.933333333333313 * sp[32] + -1.466666666666676 * sp[27] + -2.600000000000018 * sp[30];
    A[63] = -2.016666666666679 * sp[33] + -2.300000000000006 * sp[34] + -2.233333333333343 * sp[28] + -2.300000000000004 * sp[31] + -3.133333333333347 * sp[34] + -4.216666666666669 * sp[35] + -1.683333333333344 * sp[29] + -2.766666666666668 * sp[32] + -1.400000000000002 * sp[28] + -0.6833333333333311 * sp[29] + -5.08333333333332 * sp[26] + -3.433333333333321 * sp[27] + -3.133333333333337 * sp[31] + -2.599999999999992 * sp[32] + -7.933333333333318 * sp[27] + -5.866666666666649 * sp[30];
    A[64] = 2.533333333333343 * sp[33] + 4.266666666666673 * sp[34] + 1.799999999999997 * sp[28] + 4.266666666666666 * sp[31] + 4.266666666666673 * sp[34] + 8.766666666666662 * sp[35] + 1.366666666666658 * sp[29] + 5.86666666666665 * sp[32] + 1.799999999999997 * sp[28] + 1.366666666666658 * sp[29] + 3.833333333333316 * sp[26] + 5.866666666666641 * sp[27] + 4.266666666666666 * sp[31] + 5.86666666666665 * sp[32] + 5.866666666666641 * sp[27] + 11.7333333333333 * sp[30];
    A[65] = 0.8166666666666685 * sp[33] + -1.966666666666665 * sp[34] + 1.433333333333336 * sp[28] + -1.966666666666672 * sp[31] + 1.533333333333335 * sp[34] + -4.716666666666656 * sp[35] + 3.150000000000001 * sp[29] + -3.099999999999997 * sp[32] + 0.5999999999999965 * sp[28] + -0.5166666666666569 * sp[29] + 0.4166666666666629 * sp[26] + -2.433333333333322 * sp[27] + 1.533333333333331 * sp[31] + -3.266666666666639 * sp[32] + 2.066666666666667 * sp[27] + -5.866666666666645 * sp[30];
    A[66] = -1.016666666666666 * sp[33] + -1.383333333333335 * sp[34] + -1.383333333333344 * sp[28] + -1.383333333333341 * sp[31] + 0.03333333333333305 * sp[34] + 0.9416666666666658 * sp[35] + -2.291666666666682 * sp[29] + -1.383333333333341 * sp[32] + -2.866666666666654 * sp[28] + -5.258333333333316 * sp[29] + -0.2250000000000034 * sp[26] + -1.383333333333334 * sp[27] + -3.933333333333316 * sp[31] + -7.533333333333326 * sp[32] + -1.133333333333342 * sp[27] + -2.600000000000007 * sp[30];
    A[67] = 1.200000000000002 * sp[33] + 0.7666666666666759 * sp[34] + 0.7666666666666706 * sp[28] + 0.7666666666666725 * sp[31] + 0.2666666666666761 * sp[34] + -0.3833333333333117 * sp[35] + 1.416666666666679 * sp[29] + 0.7666666666666797 * sp[32] + 3.733333333333316 * sp[28] + 3.01666666666666 * sp[29] + -0.3833333333333356 * sp[26] + 0.7666666666666648 * sp[27] + 5.866666666666648 * sp[31] + 3.733333333333335 * sp[32] + 0.2666666666666687 * sp[27] + 1.200000000000003 * sp[30];
    A[68] = -0.183333333333339 * sp[33] + -0.2166666666666887 * sp[34] + -0.216666666666668 * sp[28] + -0.216666666666679 * sp[31] + -0.300000000000013 * sp[34] + 0.5249999999999733 * sp[35] + -1.041666666666674 * sp[29] + -0.2166666666666809 * sp[32] + -0.8666666666666655 * sp[28] + -1.008333333333353 * sp[29] + 0.3583333333333341 * sp[26] + -0.2166666666666812 * sp[27] + -1.933333333333338 * sp[31] + -1.533333333333369 * sp[32] + -0.4666666666666729 * sp[27] + -0.6000000000000258 * sp[30];
    A[69] = 8.01387685344759 * sp[33] + 10.37089945740277 * sp[34] + -0.9428090415820658 * sp[28] + -0.9428090415820358 * sp[31] + 13.19932658214894 * sp[34] + 11.78511301977584 * sp[35] + 0.4714045207910194 * sp[29] + -0.9428090415820602 * sp[32] + 5.656854249492384 * sp[28] + 11.78511301977581 * sp[29] + 0.4714045207910407 * sp[26] + -0.942809041582003 * sp[27] + 13.1993265821489 * sp[31] + 24.51303508113372 * sp[32] + 1.885618083164147 * sp[27];
    A[70] = -1.154700538379164 * sp[33] + -1.443375672973962 * sp[34] + -6.639528095680735 * sp[28] + -6.639528095680671 * sp[31] + 4.618802153517086 * sp[34] + 5.917840259193765 * sp[35] + -7.938566201357409 * sp[29] + -6.639528095680684 * sp[32] + -5.196152422706527 * sp[28] + -14.8667694316327 * sp[29] + -1.010362971081849 * sp[26] + -6.639528095680604 * sp[27] + 4.618802153517171 * sp[31] + -16.16580753730933 * sp[32] + -2.309401076758502 * sp[27] + -10.39230484541314 * sp[30];
    A[71] = 9.666666666666679 * sp[33] + 4.83333333333329 * sp[34] + -8.166666666666739 * sp[28] + -8.166666666666742 * sp[31] + 17.33333333333333 * sp[34] + 24.58333333333325 * sp[35] + -15.41666666666675 * sp[29] + -8.166666666666691 * sp[32] + 6.999999999999958 * sp[28] + -11.41666666666669 * sp[29] + -3.416666666666698 * sp[26] + -8.16666666666673 * sp[27] + 17.33333333333329 * sp[31] + -2.666666666666751 * sp[32] + -10.66666666666673 * sp[27] + -18.00000000000012 * sp[30];
    A[72] = -11.78511301977583 * sp[33] + -8.013876853447565 * sp[34] + 0.4714045207910904 * sp[28] + 3.299831645537263 * sp[31] + -20.74179891480541 * sp[34] + -14.37783788412649 * sp[35] + -3.064129385141614 * sp[29] + 3.299831645537273 * sp[32] + -8.485281374238545 * sp[28] + -3.064129385141709 * sp[29] + 2.592724864350711 * sp[26] + 3.299831645537225 * sp[27] + -20.74179891480538 * sp[31] + -9.428090415820671 * sp[32] + 1.88561808316418 * sp[27] + 5.656854249492359 * sp[30];
    A[73] = -7.794228634060001 * sp[33] + -6.062177826491114 * sp[34] + -6.062177826491114 * sp[28] + -0.8660254037844857 * sp[31] + -10.39230484541331 * sp[34] + -8.227241335952217 * sp[35] + -3.031088913245621 * sp[29] + -0.8660254037845029 * sp[32] + -5.196152422706646 * sp[28] + -1.299038105676658 * sp[29] + -16.88749537379651 * sp[26] + -0.8660254037844718 * sp[27] + -10.39230484541325 * sp[31] + -3.464101615137726 * sp[32] + -17.32050807568874 * sp[27] + 3.464101615137757 * sp[30];
    A[74] = -20.83333333333339 * sp[33] + -14.16666666666671 * sp[34] + -8.166666666666639 * sp[28] + -1.166666666666628 * sp[31] + -36.66666666666671 * sp[34] + -25.41666666666669 * sp[35] + -12.41666666666663 * sp[29] + -1.166666666666712 * sp[32] + -14.99999999999994 * sp[28] + -5.416666666666667 * sp[29] + -12.41666666666658 * sp[26] + -1.166666666666599 * sp[27] + -36.66666666666663 * sp[31] + -16.66666666666672 * sp[32] + -24.66666666666656 * sp[27] + 10.00000000000006 * sp[30];
    A[75] = -1.008333333333336 * sp[33] + 0.1416666666666654 * sp[34] + 0.1083333333333318 * sp[28] + 0.1083333333333278 * sp[31] + 1.183333333333329 * sp[34] + -0.8374999999999975 * sp[35] + 1.145833333333344 * sp[29] + 0.1083333333333416 * sp[32] + -2.116666666666676 * sp[28] + 0.5125000000000003 * sp[29] + -0.6375000000000116 * sp[26] + 0.1083333333333229 * sp[27] + 1.183333333333329 * sp[31] + -0.4666666666666585 * sp[32] + 0.4000000000000108 * sp[27] + 0.09166666666667866 * sp[30];
    A[76] = 1.26666666666667 * sp[33] + -0.8666666666666641 * sp[34] + 0.3666666666666694 * sp[28] + 0.3666666666666769 * sp[31] + -2.116666666666664 * sp[34] + 3.008333333333314 * sp[35] + -1.958333333333338 * sp[29] + 0.3666666666666666 * sp[32] + 2.483333333333342 * sp[28] + -2.024999999999999 * sp[29] + 1.275000000000012 * sp[26] + 0.3666666666666801 * sp[27] + -2.116666666666668 * sp[31] + 1.849999999999973 * sp[32] + -1.050000000000006 * sp[27] + -1.016666666666673 * sp[30];
    A[77] = 0.4083333333333337 * sp[33] + 1.391666666666667 * sp[34] + -0.3083333333333367 * sp[28] + -0.3083333333333387 * sp[31] + -0.9833333333333313 * sp[34] + -4.29583333333332 * sp[35] + 1.187500000000007 * sp[29] + -0.3083333333333375 * sp[32] + 0.716666666666667 * sp[28] + 2.887500000000002 * sp[29] + -0.7625000000000071 * sp[26] + -0.3083333333333393 * sp[27] + -0.9833333333333336 * sp[31] + -2.79999999999999 * sp[32] + 0.7333333333333431 * sp[27] + 1.508333333333338 * sp[30];
    A[78] = -0.03333333333333428 * sp[33] + -0.4750000000000005 * sp[34] + 0.1583333333333356 * sp[28] + -0.4749999999999961 * sp[31] + 0.8583333333333365 * sp[34] + 1.691666666666666 * sp[35] + 0.2583333333333276 * sp[29] + 1.091666666666663 * sp[32] + 0.1583333333333346 * sp[28] + -1.075000000000001 * sp[29] + 1.625000000000003 * sp[26] + -0.2416666666666614 * sp[27] + 0.8583333333333407 * sp[31] + 1.09166666666667 * sp[32] + 2.424999999999991 * sp[27] + 2.183333333333327 * sp[30];
    A[79] = 0.8166666666666685 * sp[33] + 1.533333333333335 * sp[34] + 0.5999999999999965 * sp[28] + 1.533333333333331 * sp[31] + -1.966666666666665 * sp[34] + -4.716666666666656 * sp[35] + -0.5166666666666569 * sp[29] + -3.266666666666639 * sp[32] + 1.433333333333336 * sp[28] + 3.150000000000001 * sp[29] + 0.4166666666666629 * sp[26] + 2.066666666666667 * sp[27] + -1.966666666666672 * sp[31] + -3.099999999999997 * sp[32] + -2.433333333333322 * sp[27] + -5.866666666666645 * sp[30];
    A[80] = 0.6333333333333347 * sp[33] + -1.058333333333332 * sp[34] + 1.241666666666671 * sp[28] + -1.058333333333333 * sp[31] + -1.058333333333332 * sp[34] + 3.441666666666649 * sp[35] + -2.324999999999999 * sp[29] + 2.174999999999978 * sp[32] + 1.241666666666671 * sp[28] + -2.324999999999999 * sp[29] + 2.708333333333344 * sp[26] + -1.825000000000004 * sp[27] + -1.058333333333333 * sp[31] + 2.174999999999978 * sp[32] + -1.825000000000004 * sp[27] + 3.683333333333303 * sp[30];
    A[81] = 0.09166666666666852 * sp[33] + -0.01666666666666396 * sp[34] + -0.01666666666667001 * sp[28] + -0.0166666666666699 * sp[31] + -0.3083333333333314 * sp[34] + -1.054166666666676 * sp[35] + 0.7291666666666788 * sp[29] + -0.01666666666666494 * sp[32] + 0.5583333333333315 * sp[28] + 0.9625000000000015 * sp[29] + -0.3875000000000071 * sp[26] + -0.01666666666667183 * sp[27] + 1.341666666666665 * sp[31] + 3.224999999999997 * sp[32] + 0.3583333333333485 * sp[27] + 1.091666666666679 * sp[30];
    A[82] = -0.6000000000000023 * sp[33] + -0.2166666666666635 * sp[34] + -0.2166666666666643 * sp[28] + -0.2166666666666613 * sp[31] + -0.4666666666666692 * sp[34] + 0.35833333333332 * sp[35] + -1.041666666666683 * sp[29] + -0.2166666666666772 * sp[32] + -1.533333333333328 * sp[28] + -1.008333333333324 * sp[29] + 0.5250000000000129 * sp[26] + -0.2166666666666556 * sp[27] + -1.933333333333329 * sp[31] + -0.8666666666666771 * sp[32] + -0.3000000000000159 * sp[27] + -0.1833333333333499 * sp[30];
    A[83] = 0.5083333333333339 * sp[33] + -0.1833333333333452 * sp[34] + -0.1833333333333355 * sp[28] + -0.1833333333333427 * sp[31] + 0.7750000000000021 * sp[34] + -1.012499999999993 * sp[35] + 1.604166666666673 * sp[29] + -0.1833333333333292 * sp[32] + 0.9749999999999965 * sp[28] + 0.170833333333315 * sp[29] + -1.012500000000012 * sp[26] + -0.1833333333333469 * sp[27] + 0.5916666666666666 * sp[31] + 0.9750000000000063 * sp[32] + 0.7750000000000069 * sp[27] + 0.5083333333333425 * sp[30];
    A[84] = 1.885618083164132 * sp[33] + 3.064129385141729 * sp[34] + 1.649915822768612 * sp[28] + 1.649915822768627 * sp[31] + -5.421151989096869 * sp[34] + -1.178511301977545 * sp[35] + -2.592724864350643 * sp[29] + 1.649915822768639 * sp[32] + 3.064129385141711 * sp[28] + 3.535533905932768 * sp[29] + 2.12132034355964 * sp[26] + 1.64991582276862 * sp[27] + -5.421151989096884 * sp[31] + -13.43502884254441 * sp[32] + -2.121320343559616 * sp[27] + -2.357022603955129 * sp[30];
    A[85] = -4.474464586219598 * sp[33] + -0.7216878364869839 * sp[34] + 1.876388374866277 * sp[28] + 1.876388374866304 * sp[31] + -3.752776749732468 * sp[34] + -0.07216878364872875 * sp[35] + -1.804219591217509 * sp[29] + 1.876388374866305 * sp[32] + -8.948929172439223 * sp[28] + 0.2165063509461653 * sp[29] + 1.948557158514979 * sp[26] + 1.876388374866298 * sp[27] + -3.752776749732479 * sp[31] + 5.196152422706618 * sp[32] + -1.732050807568799 * sp[27] + 1.587713240271522 * sp[30];
    A[86] = 5.583333333333345 * sp[33] + 0.9166666666666425 * sp[34] + -2.583333333333354 * sp[28] + -2.58333333333336 * sp[31] + -10.33333333333332 * sp[34] + -18.95833333333326 * sp[35] + 6.041666666666681 * sp[29] + -2.583333333333382 * sp[32] + 10.6666666666667 * sp[28] + 4.874999999999947 * sp[29] + -4.125000000000017 * sp[26] + -2.583333333333353 * sp[27] + -10.33333333333333 * sp[31] + 0.5 * sp[32] + 4.500000000000041 * sp[27] + 11.08333333333335 * sp[30];
    A[87] = -5.892556509887909 * sp[33] + -1.885618083164137 * sp[34] + -6.128258770283416 * sp[28] + -0.4714045207910277 * sp[31] + 11.54941075938026 * sp[34] + 4.831896338108094 * sp[35] + 6.246109900481125 * sp[29] + -0.4714045207910498 * sp[32] + -11.07800623858927 * sp[28] + -3.181980515339467 * sp[29] + -13.08147545195115 * sp[26] + -0.4714045207910118 * sp[27] + 11.54941075938029 * sp[31] + 3.535533905932804 * sp[32] + 4.949747468305797 * sp[27] + -1.649915822768606 * sp[30];
    A[88] = 3.897114317029998 * sp[33] + 0.8660254037844368 * sp[34] + 0.8660254037844447 * sp[28] + -1.732050807568878 * sp[31] + -1.29903810567666 * sp[34] + -0.2165063509460685 * sp[35] + -2.814582562299359 * sp[29] + -1.732050807568807 * sp[32] + 9.093266739736679 * sp[28] + 0.6495190528383197 * sp[29] + 8.443747686898307 * sp[26] + -1.732050807568878 * sp[27] + -1.299038105676647 * sp[31] + -0.4330127018921908 * sp[32] + -2.165063509461031 * sp[27] + -3.897114317029976 * sp[30];
    A[89] = -10.41666666666669 * sp[33] + -3.333333333333351 * sp[34] + -6.333333333333336 * sp[28] + 0.1666666666666692 * sp[31] + 20.41666666666664 * sp[34] + 8.541666666666698 * sp[35] + 12.04166666666663 * sp[29] + 0.1666666666668544 * sp[32] + -19.58333333333339 * sp[28] + -5.625000000000004 * sp[29] + -12.12500000000005 * sp[26] + 0.1666666666666645 * sp[27] + 20.41666666666669 * sp[31] + 6.250000000000114 * sp[32] + 15.24999999999996 * sp[27] + -12.91666666666647 * sp[30];
    A[90] = -1.091666666666675 * sp[33] + -0.7333333333333457 * sp[34] + 2.133333333333354 * sp[28] + 1.149999999999997 * sp[31] + -1.108333333333343 * sp[34] + -0.3624999999999964 * sp[35] + 1.154166666666659 * sp[29] + 1.116666666666659 * sp[32] + -1.108333333333342 * sp[28] + -1.479166666666687 * sp[29] + 3.170833333333356 * sp[26] + 1.149999999999999 * sp[27] + -1.108333333333338 * sp[31] + -1.108333333333342 * sp[32] + 2.191666666666669 * sp[27] + 1.008333333333329 * sp[30];
    A[91] = 0.1833333333333387 * sp[33] + -0.1166666666666594 * sp[34] + -0.6833333333333468 * sp[28] + 0.9500000000000024 * sp[31] + -0.03333333333332775 * sp[34] + -0.8583333333333442 * sp[35] + 0.1083333333333328 * sp[29] + -0.3166666666666937 * sp[32] + -0.0333333333333363 * sp[28] + 0.7083333333333506 * sp[29] + -1.258333333333349 * sp[26] + 0.9500000000000093 * sp[27] + -0.03333333333333688 * sp[31] + -0.03333333333332966 * sp[32] + -0.4666666666666696 * sp[27] + 0.06666666666665713 * sp[30];
    A[92] = -0.5083333333333316 * sp[33] + 0.2666666666666673 * sp[34] + 0.466666666666674 * sp[28] + 0.6500000000000005 * sp[31] + -0.6916666666666644 * sp[34] + 1.095833333333336 * sp[35] + 0.1125000000000044 * sp[29] + 2.283333333333357 * sp[32] + -0.6916666666666722 * sp[28] + -1.520833333333347 * sp[29] + 1.295833333333346 * sp[26] + 0.650000000000001 * sp[27] + -0.6916666666666702 * sp[31] + -0.6916666666666721 * sp[32] + 0.9416666666666742 * sp[27] + 1.591666666666681 * sp[30];
    A[93] = 1.508333333333336 * sp[33] + 0.7750000000000072 * sp[34] + 4.308333333333319 * sp[28] + 2.591666666666665 * sp[31] + 1.816666666666671 * sp[34] + 0.3208333333333345 * sp[35] + 7.504166666666657 * sp[29] + 4.308333333333326 * sp[32] + 1.81666666666668 * sp[28] + 2.270833333333349 * sp[29] + 0.3208333333333446 * sp[26] + 0.7750000000000161 * sp[27] + 1.816666666666675 * sp[31] + 1.816666666666675 * sp[32] + 1.816666666666672 * sp[27] + 1.508333333333341 * sp[30];
    A[94] = -1.016666666666666 * sp[33] + 0.03333333333333305 * sp[34] + -2.866666666666654 * sp[28] + -3.933333333333316 * sp[31] + -1.383333333333335 * sp[34] + 0.9416666666666658 * sp[35] + -5.258333333333316 * sp[29] + -7.533333333333326 * sp[32] + -1.383333333333344 * sp[28] + -2.291666666666682 * sp[29] + -0.2250000000000034 * sp[26] + -1.133333333333342 * sp[27] + -1.383333333333341 * sp[31] + -1.383333333333341 * sp[32] + -1.383333333333334 * sp[27] + -2.600000000000007 * sp[30];
    A[95] = 0.09166666666666852 * sp[33] + -0.3083333333333314 * sp[34] + 0.5583333333333315 * sp[28] + 1.341666666666665 * sp[31] + -0.01666666666666396 * sp[34] + -1.054166666666676 * sp[35] + 0.9625000000000015 * sp[29] + 3.224999999999997 * sp[32] + -0.01666666666667001 * sp[28] + 0.7291666666666788 * sp[29] + -0.3875000000000071 * sp[26] + 0.3583333333333485 * sp[27] + -0.0166666666666699 * sp[31] + -0.01666666666666494 * sp[32] + -0.01666666666667183 * sp[27] + 1.091666666666679 * sp[30];
    A[96] = 3.683333333333331 * sp[33] + 5.508333333333316 * sp[34] + 1.508333333333344 * sp[28] + 2.274999999999999 * sp[31] + 5.508333333333316 * sp[34] + 10.04166666666666 * sp[35] + 1.008333333333332 * sp[29] + 3.24166666666667 * sp[32] + 1.508333333333344 * sp[28] + 1.008333333333332 * sp[29] + 2.775000000000016 * sp[26] + 2.275000000000006 * sp[27] + 2.274999999999999 * sp[31] + 3.24166666666667 * sp[32] + 2.275000000000006 * sp[27] + 2.633333333333339 * sp[30];
    A[97] = -5.866666666666667 * sp[33] + -3.433333333333323 * sp[34] + -2.766666666666688 * sp[28] + -2.299999999999993 * sp[31] + -7.933333333333307 * sp[34] + -5.083333333333311 * sp[35] + -1.683333333333321 * sp[29] + -2.233333333333314 * sp[32] + -2.60000000000002 * sp[28] + -0.6833333333333371 * sp[29] + -4.216666666666692 * sp[26] + -2.3 * sp[27] + -3.133333333333328 * sp[31] + -1.399999999999994 * sp[32] + -3.133333333333334 * sp[27] + -2.016666666666658 * sp[30];
    A[98] = 2.183333333333339 * sp[33] + -0.2416666666666677 * sp[34] + 1.091666666666682 * sp[28] + -0.4750000000000049 * sp[31] + 2.424999999999997 * sp[34] + 1.625000000000023 * sp[35] + 0.2583333333333306 * sp[29] + 0.1583333333333461 * sp[32] + 1.091666666666679 * sp[28] + -1.075000000000002 * sp[29] + 1.691666666666682 * sp[26] + -0.4750000000000093 * sp[27] + 0.8583333333333323 * sp[31] + 0.1583333333333472 * sp[32] + 0.8583333333333334 * sp[27] + -0.0333333333333312 * sp[30];
    A[99] = -4.006938426723782 * sp[33] + -6.835365551469952 * sp[34] + 5.892556509887915 * sp[28] + 9.19238815542511 * sp[31] + -5.185449728701364 * sp[34] + -18.97403196183914 * sp[35] + 5.067598598503553 * sp[29] + 5.421151989096738 * sp[32] + -5.185449728701405 * sp[28] + -4.360491817317076 * sp[29] + 8.36743024404084 * sp[26] + 9.192388155425146 * sp[27] + -5.185449728701391 * sp[31] + -10.84230397819382 * sp[32] + 7.542472332656502 * sp[27] + 5.892556509887847 * sp[30];
    A[100] = 2.742413778650664 * sp[33] + 17.89785834487829 * sp[34] + 10.96965511460294 * sp[28] + 19.91858428704208 * sp[31] + 0.7216878364868009 * sp[34] + 24.75389279150499 * sp[35] + 9.165435523385273 * sp[29] + 19.34123401785231 * sp[32] + 0.7216878364870007 * sp[28] + 2.525907427704572 * sp[29] + 18.11436469582458 * sp[26] + 19.91858428704215 * sp[27] + 0.7216878364869603 * sp[31] + 5.051814855409132 * sp[32] + 16.31014510460694 * sp[27] + 17.46484564298614 * sp[30];
    A[101] = -1.083333333333305 * sp[33] + 12.16666666666666 * sp[34] + -1.833333333333336 * sp[28] + 2.000000000000015 * sp[31] + -2.416666666666631 * sp[34] + 27.95833333333333 * sp[35] + -2.041666666666619 * sp[29] + 14.33333333333353 * sp[32] + -2.416666666666693 * sp[28] + -2.208333333333327 * sp[29] + 1.791666666666699 * sp[26] + 2.000000000000015 * sp[27] + -2.416666666666685 * sp[31] + 8.083333333333394 * sp[32] + 1.583333333333382 * sp[27] + 9.416666666666789 * sp[30];
    A[102] = 2.357022603955147 * sp[33] + 0.2357022603954988 * sp[34] + -11.07800623858928 * sp[28] + -7.778174593052077 * sp[31] + 4.00693842672376 * sp[34] + -0.2357022603954801 * sp[35] + -12.96362432175339 * sp[29] + -8.720983634634065 * sp[32] + 4.006938426723815 * sp[28] + 4.4783429475148 * sp[29] + -8.249579113843112 * sp[26] + -7.778174593052119 * sp[27] + 4.006938426723807 * sp[31] + 4.006938426723782 * sp[32] + -8.720983634634102 * sp[27] + -7.54247233265655 * sp[30];
    A[103] = 10.3923048454133 * sp[33] + 7.361215932167804 * sp[34] + 7.361215932167632 * sp[28] + -6.495190528383207 * sp[31] + 11.69134295108997 * sp[34] + 6.062177826491064 * sp[35] + 12.99038105676648 * sp[29] + -8.227241335952147 * sp[32] + 11.69134295109001 * sp[28] + 12.9903810567667 * sp[29] + -7.79422863405994 * sp[26] + -6.495190528383184 * sp[27] + 11.69134295108997 * sp[31] + 11.69134295108998 * sp[32] + -3.897114317029977 * sp[27] + -6.062177826490993 * sp[30];
    A[104] = 4.166666666666642 * sp[33] + 0.416666666666635 * sp[34] + 8.416666666666643 * sp[28] + 2.749999999999941 * sp[31] + 7.083333333333307 * sp[34] + -0.4166666666666083 * sp[35] + 13.58333333333325 * sp[29] + -8.916666666666913 * sp[32] + 7.083333333333419 * sp[28] + 7.916666666666668 * sp[29] + 1.916666666666708 * sp[26] + 2.749999999999976 * sp[27] + 7.083333333333401 * sp[31] + 7.08333333333336 * sp[32] + 3.083333333333333 * sp[27] + -3.333333333333458 * sp[30];
    A[105] = 2.600000000000015 * sp[33] + 1.466666666666685 * sp[34] + -4.933333333333369 * sp[28] + -2.13333333333332 * sp[31] + 1.216666666666668 * sp[34] + 0.3083333333333419 * sp[35] + -1.05833333333333 * sp[29] + -0.8999999999999915 * sp[32] + 1.216666666666674 * sp[28] + 2.375000000000033 * sp[29] + -7.258333333333391 * sp[26] + -2.133333333333326 * sp[27] + 1.216666666666664 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333329 * sp[27] + -1.266666666666652 * sp[30];
    A[106] = -1.200000000000008 * sp[33] + -0.9333333333333422 * sp[34] + 2.533333333333358 * sp[28] + -3.066666666666682 * sp[31] + -0.433333333333328 * sp[34] + 0.2166666666666532 * sp[35] + 0.2833333333333361 * sp[29] + -1.199999999999987 * sp[32] + -0.4333333333333335 * sp[28] + -1.583333333333361 * sp[29] + 3.683333333333371 * sp[26] + -3.066666666666696 * sp[27] + -0.4333333333333259 * sp[31] + -0.4333333333333472 * sp[32] + 1.433333333333335 * sp[27] + -1.633333333333324 * sp[30];
    A[107] = 0.5999999999999991 * sp[33] + 0.1333333333333369 * sp[34] + -0.9333333333333471 * sp[28] + 0.5333333333333369 * sp[31] + 0.3833333333333365 * sp[34] + -0.4416666666666494 * sp[35] + -0.1416666666666738 * sp[29] + 0.09999999999999121 * sp[32] + 0.3833333333333359 * sp[28] + 0.9583333333333445 * sp[29] + -1.675000000000017 * sp[26] + 0.5333333333333441 * sp[27] + 0.3833333333333362 * sp[31] + 0.3833333333333449 * sp[32] + -0.8833333333333391 * sp[27] + 0.06666666666665821 * sp[30];
    A[108] = -2.600000000000007 * sp[33] + -1.133333333333349 * sp[34] + -7.533333333333313 * sp[28] + -3.933333333333342 * sp[31] + -1.38333333333334 * sp[34] + -0.2250000000000117 * sp[35] + -5.258333333333323 * sp[29] + -2.866666666666672 * sp[32] + -1.38333333333334 * sp[28] + -2.291666666666688 * sp[29] + 0.941666666666667 * sp[26] + 0.0333333333333149 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333342 * sp[32] + -1.383333333333327 * sp[27] + -1.016666666666675 * sp[30];
    A[109] = 1.200000000000002 * sp[33] + 0.2666666666666761 * sp[34] + 3.733333333333316 * sp[28] + 5.866666666666648 * sp[31] + 0.7666666666666759 * sp[34] + -0.3833333333333117 * sp[35] + 3.01666666666666 * sp[29] + 3.733333333333335 * sp[32] + 0.7666666666666706 * sp[28] + 1.416666666666679 * sp[29] + -0.3833333333333356 * sp[26] + 0.2666666666666687 * sp[27] + 0.7666666666666725 * sp[31] + 0.7666666666666797 * sp[32] + 0.7666666666666648 * sp[27] + 1.200000000000003 * sp[30];
    A[110] = -0.6000000000000023 * sp[33] + -0.4666666666666692 * sp[34] + -1.533333333333328 * sp[28] + -1.933333333333329 * sp[31] + -0.2166666666666635 * sp[34] + 0.35833333333332 * sp[35] + -1.008333333333324 * sp[29] + -0.8666666666666771 * sp[32] + -0.2166666666666643 * sp[28] + -1.041666666666683 * sp[29] + 0.5250000000000129 * sp[26] + -0.3000000000000159 * sp[27] + -0.2166666666666613 * sp[31] + -0.2166666666666772 * sp[32] + -0.2166666666666556 * sp[27] + -0.1833333333333499 * sp[30];
    A[111] = -5.866666666666667 * sp[33] + -7.933333333333307 * sp[34] + -2.60000000000002 * sp[28] + -3.133333333333328 * sp[31] + -3.433333333333323 * sp[34] + -5.083333333333311 * sp[35] + -0.6833333333333371 * sp[29] + -1.399999999999994 * sp[32] + -2.766666666666688 * sp[28] + -1.683333333333321 * sp[29] + -4.216666666666692 * sp[26] + -3.133333333333334 * sp[27] + -2.299999999999993 * sp[31] + -2.233333333333314 * sp[32] + -2.3 * sp[27] + -2.016666666666658 * sp[30];
    A[112] = 11.73333333333334 * sp[33] + 5.866666666666647 * sp[34] + 5.866666666666705 * sp[28] + 4.266666666666646 * sp[31] + 5.866666666666647 * sp[34] + 3.833333333333315 * sp[35] + 1.366666666666662 * sp[29] + 1.799999999999981 * sp[32] + 5.866666666666705 * sp[28] + 1.366666666666662 * sp[29] + 8.766666666666724 * sp[26] + 4.266666666666659 * sp[27] + 4.266666666666646 * sp[31] + 1.799999999999981 * sp[32] + 4.266666666666659 * sp[27] + 2.533333333333307 * sp[30];
    A[113] = -5.866666666666677 * sp[33] + 2.066666666666682 * sp[34] + -3.266666666666695 * sp[28] + 1.533333333333353 * sp[31] + -2.433333333333326 * sp[34] + 0.4166666666666561 * sp[35] + -0.5166666666666671 * sp[29] + 0.5999999999999966 * sp[32] + -3.100000000000021 * sp[28] + 3.15000000000002 * sp[29] + -4.716666666666707 * sp[26] + 1.533333333333361 * sp[27] + -1.966666666666656 * sp[31] + 1.433333333333321 * sp[32] + -1.966666666666665 * sp[27] + 0.816666666666669 * sp[30];
    A[114] = 5.656854249492409 * sp[33] + 1.885618083164119 * sp[34] + -9.42809041582067 * sp[28] + -20.74179891480539 * sp[31] + 3.299831645537259 * sp[34] + 2.592724864350729 * sp[35] + -3.064129385141682 * sp[29] + -8.485281374238484 * sp[32] + 3.299831645537255 * sp[28] + -3.06412938514173 * sp[29] + -14.37783788412653 * sp[26] + -20.74179891480547 * sp[27] + 3.29983164553725 * sp[31] + 0.4714045207910975 * sp[32] + -8.013876853447512 * sp[27] + -11.7851130197757 * sp[30];
    A[115] = 10.39230484541332 * sp[33] + -30.02221399786041 * sp[34] + -16.16580753730961 * sp[28] + -36.95041722813604 * sp[31] + -1.443375672973985 * sp[34] + -19.19689645055489 * sp[35] + -5.340489990004037 * sp[29] + -15.58845726811978 * sp[32] + -1.443375672974093 * sp[28] + -12.26869322027952 * sp[29] + -26.12509968083068 * sp[26] + -36.95041722813616 * sp[27] + -1.443375672974045 * sp[31] + -10.1036297108183 * sp[32] + -15.29978213352506 * sp[27] + -21.93931022920565 * sp[30];
    A[116] = -2.000000000000033 * sp[33] + -2.666666666666618 * sp[34] + 5.333333333333343 * sp[28] + 9.333333333333318 * sp[31] + -0.1666666666666444 * sp[34] + -8.416666666666615 * sp[35] + 1.583333333333278 * sp[29] + 2.999999999999909 * sp[32] + -0.1666666666666522 * sp[28] + 3.583333333333338 * sp[29] + 5.58333333333337 * sp[26] + 9.333333333333382 * sp[27] + -0.1666666666666332 * sp[31] + -1.16666666666669 * sp[32] + 1.833333333333291 * sp[27] + 3.666666666666564 * sp[30];
    A[117] = 1.885618083164121 * sp[34] + 24.5130350811337 * sp[28] + 13.19932658214896 * sp[31] + -0.9428090415821101 * sp[34] + 0.4714045207910074 * sp[35] + 11.78511301977577 * sp[29] + 5.656854249492396 * sp[32] + -0.9428090415820871 * sp[28] + 0.4714045207910695 * sp[29] + 11.78511301977584 * sp[26] + 13.19932658214903 * sp[27] + -0.9428090415821091 * sp[31] + -0.9428090415820647 * sp[32] + 10.37089945740265 * sp[27] + 8.01387685344757 * sp[30];
    A[118] = -20.78460969082662 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541311 * sp[28] + 17.3205080756886 * sp[31] + -10.3923048454133 * sp[34] + -3.464101615137791 * sp[35] + -17.32050807568872 * sp[29] + 3.464101615137627 * sp[32] + -10.39230484541332 * sp[28] + -17.32050807568897 * sp[29] + 24.24871130596439 * sp[26] + 17.3205080756886 * sp[27] + -10.39230484541326 * sp[31] + -10.39230484541332 * sp[32] + 3.464101615137783 * sp[27] + 7.794228634059758 * sp[30];
    A[119] = 3.333333333333329 * sp[34] + -12.66666666666665 * sp[28] + -4.666666666666631 * sp[31] + -1.666666666666742 * sp[34] + 0.8333333333332931 * sp[35] + -7.166666666666653 * sp[29] + -7.999999999999895 * sp[32] + -1.666666666666716 * sp[28] + 0.8333333333333979 * sp[29] + -7.166666666666774 * sp[26] + -4.666666666666654 * sp[27] + -1.666666666666749 * sp[31] + -1.66666666666667 * sp[32] + -3.666666666666684 * sp[27] + -5.833333333333214 * sp[30];
    A[120] = -1.508333333333342 * sp[33] + -0.7333333333333413 * sp[34] + 2.800000000000018 * sp[28] + 0.9833333333333238 * sp[31] + 0.3083333333333495 * sp[34] + 0.7625000000000099 * sp[35] + -2.887500000000019 * sp[29] + -0.7166666666666586 * sp[32] + 0.3083333333333361 * sp[28] + -1.187500000000015 * sp[29] + 4.295833333333371 * sp[26] + 0.9833333333333308 * sp[27] + 0.3083333333333491 * sp[31] + 0.3083333333333433 * sp[32] + -1.391666666666691 * sp[27] + -0.4083333333333333 * sp[30];
    A[121] = 1.016666666666669 * sp[33] + 1.050000000000003 * sp[34] + -1.850000000000012 * sp[28] + 2.11666666666668 * sp[31] + -0.366666666666692 * sp[34] + -1.275000000000003 * sp[35] + 2.025000000000007 * sp[29] + -2.483333333333348 * sp[32] + -0.3666666666666703 * sp[28] + 1.958333333333345 * sp[29] + -3.008333333333361 * sp[26] + 2.116666666666683 * sp[27] + -0.3666666666666862 * sp[31] + -0.3666666666666694 * sp[32] + 0.8666666666666758 * sp[27] + -1.266666666666683 * sp[30];
    A[122] = -0.09166666666666883 * sp[33] + -0.4000000000000071 * sp[34] + 0.4666666666666748 * sp[28] + -1.183333333333336 * sp[31] + -0.1083333333333436 * sp[34] + 0.6374999999999785 * sp[35] + -0.5124999999999963 * sp[29] + 2.11666666666668 * sp[32] + -0.1083333333333339 * sp[28] + -1.145833333333339 * sp[29] + 0.8375000000000103 * sp[26] + -1.18333333333334 * sp[27] + -0.1083333333333392 * sp[31] + -0.1083333333333458 * sp[32] + -0.1416666666666671 * sp[27] + 1.008333333333344 * sp[30];
    A[123] = 1.091666666666675 * sp[33] + 0.3583333333333452 * sp[34] + 3.225 * sp[28] + 1.34166666666668 * sp[31] + -0.016666666666659 * sp[34] + -0.3874999999999941 * sp[35] + 0.9625000000000112 * sp[29] + 0.5583333333333422 * sp[32] + -0.01666666666666661 * sp[28] + 0.7291666666666772 * sp[29] + -1.05416666666667 * sp[26] + -0.3083333333333239 * sp[27] + -0.01666666666666641 * sp[31] + -0.0166666666666677 * sp[32] + -0.01666666666665874 * sp[27] + 0.09166666666667309 * sp[30];
    A[124] = -0.183333333333339 * sp[33] + -0.300000000000013 * sp[34] + -0.8666666666666655 * sp[28] + -1.933333333333338 * sp[31] + -0.2166666666666887 * sp[34] + 0.5249999999999733 * sp[35] + -1.008333333333353 * sp[29] + -1.533333333333369 * sp[32] + -0.216666666666668 * sp[28] + -1.041666666666674 * sp[29] + 0.3583333333333341 * sp[26] + -0.4666666666666729 * sp[27] + -0.216666666666679 * sp[31] + -0.2166666666666809 * sp[32] + -0.2166666666666812 * sp[27] + -0.6000000000000258 * sp[30];
    A[125] = 0.5083333333333339 * sp[33] + 0.7750000000000021 * sp[34] + 0.9749999999999965 * sp[28] + 0.5916666666666666 * sp[31] + -0.1833333333333452 * sp[34] + -1.012499999999993 * sp[35] + 0.170833333333315 * sp[29] + 0.9750000000000063 * sp[32] + -0.1833333333333355 * sp[28] + 1.604166666666673 * sp[29] + -1.012500000000012 * sp[26] + 0.7750000000000069 * sp[27] + -0.1833333333333427 * sp[31] + -0.1833333333333292 * sp[32] + -0.1833333333333469 * sp[27] + 0.5083333333333425 * sp[30];
    A[126] = 2.183333333333339 * sp[33] + 2.424999999999997 * sp[34] + 1.091666666666679 * sp[28] + 0.8583333333333323 * sp[31] + -0.2416666666666677 * sp[34] + 1.625000000000023 * sp[35] + -1.075000000000002 * sp[29] + 0.1583333333333472 * sp[32] + 1.091666666666682 * sp[28] + 0.2583333333333306 * sp[29] + 1.691666666666682 * sp[26] + 0.8583333333333334 * sp[27] + -0.4750000000000049 * sp[31] + 0.1583333333333461 * sp[32] + -0.4750000000000093 * sp[27] + -0.0333333333333312 * sp[30];
    A[127] = -5.866666666666677 * sp[33] + -2.433333333333326 * sp[34] + -3.100000000000021 * sp[28] + -1.966666666666656 * sp[31] + 2.066666666666682 * sp[34] + 0.4166666666666561 * sp[35] + 3.15000000000002 * sp[29] + 1.433333333333321 * sp[32] + -3.266666666666695 * sp[28] + -0.5166666666666671 * sp[29] + -4.716666666666707 * sp[26] + -1.966666666666665 * sp[27] + 1.533333333333353 * sp[31] + 0.5999999999999966 * sp[32] + 1.533333333333361 * sp[27] + 0.816666666666669 * sp[30];
    A[128] = 3.683333333333342 * sp[33] + -1.825000000000014 * sp[34] + 2.175000000000014 * sp[28] + -1.058333333333348 * sp[31] + -1.825000000000014 * sp[34] + 2.708333333333341 * sp[35] + -2.325000000000012 * sp[29] + 1.241666666666681 * sp[32] + 2.175000000000014 * sp[28] + -2.325000000000012 * sp[29] + 3.441666666666697 * sp[26] + -1.058333333333348 * sp[27] + -1.058333333333348 * sp[31] + 1.241666666666681 * sp[32] + -1.058333333333348 * sp[27] + 0.6333333333333455 * sp[30];
    A[129] = -1.649915822768638 * sp[33] + 4.949747468305816 * sp[34] + 3.535533905932762 * sp[28] + 11.54941075938029 * sp[31] + -0.4714045207910864 * sp[34] + -13.08147545195122 * sp[35] + -3.1819805153395 * sp[29] + -11.07800623858926 * sp[32] + -0.4714045207910367 * sp[28] + 6.246109900481182 * sp[29] + 4.831896338108113 * sp[26] + 11.54941075938032 * sp[27] + -0.471404520791058 * sp[31] + -6.128258770283488 * sp[32] + -1.885618083164179 * sp[27] + -5.892556509887953 * sp[30];
    A[130] = -13.134718624064 * sp[33] + 12.12435565298213 * sp[34] + 5.196152422706698 * sp[28] + 17.03183294109399 * sp[31] + -0.7216878364869126 * sp[34] + -6.278684177437078 * sp[35] + -4.546633369868337 * sp[29] + -12.41303078757693 * sp[32] + -0.721687836486977 * sp[28] + 9.021097956087914 * sp[29] + 7.289047148519089 * sp[26] + 17.03183294109403 * sp[27] + -0.7216878364869546 * sp[31] + -5.051814855409191 * sp[32] + -2.453738644055986 * sp[27] + -7.072540797572987 * sp[30];
    A[131] = 3.083333333333333 * sp[33] + -9.500000000000046 * sp[34] + -3.500000000000001 * sp[28] + -11.33333333333333 * sp[31] + -1.583333333333446 * sp[34] + 13.37500000000003 * sp[35] + 3.375000000000088 * sp[29] + 17.66666666666675 * sp[32] + -1.583333333333354 * sp[28] + -8.458333333333334 * sp[29] + -4.458333333333372 * sp[26] + -11.33333333333337 * sp[27] + -1.583333333333415 * sp[31] + 3.916666666666713 * sp[32] + 2.416666666666729 * sp[27] + 8.583333333333419 * sp[30];
    A[132] = -2.357022603955141 * sp[33] + -2.121320343559613 * sp[34] + -13.43502884254444 * sp[28] + -5.42115198909689 * sp[31] + 1.649915822768738 * sp[34] + 2.121320343559725 * sp[35] + 3.535533905932831 * sp[29] + 3.06412938514175 * sp[32] + 1.649915822768629 * sp[28] + -2.592724864350686 * sp[29] + -1.178511301977582 * sp[26] + -5.421151989096927 * sp[27] + 1.649915822768697 * sp[31] + 1.649915822768657 * sp[32] + 3.064129385141805 * sp[27] + 1.885618083164176 * sp[30];
    A[133] = 10.39230484541334 * sp[33] + 3.031088913245607 * sp[34] + 3.031088913245486 * sp[28] + -10.82531754730541 * sp[31] + -1.299038105676697 * sp[34] + -2.598076211353377 * sp[35] + 4.33012701892232 * sp[29] + 4.763139720814346 * sp[32] + -1.299038105676672 * sp[28] + 4.330127018922287 * sp[29] + -16.45448267190443 * sp[26] + -10.82531754730541 * sp[27] + -1.299038105676725 * sp[31] + -1.299038105676729 * sp[32] + 0.4330127018923184 * sp[27] + 2.598076211353316 * sp[30];
    A[134] = -4.16666666666664 * sp[33] + -3.74999999999995 * sp[34] + 4.250000000000016 * sp[28] + 1.91666666666668 * sp[31] + 2.91666666666689 * sp[34] + 3.750000000000146 * sp[35] + -2.249999999999912 * sp[29] + -13.08333333333324 * sp[32] + 2.916666666666702 * sp[28] + -4.583333333333354 * sp[29] + 9.416666666666766 * sp[26] + 1.916666666666692 * sp[27] + 2.916666666666819 * sp[31] + 2.91666666666675 * sp[32] + -1.08333333333327 * sp[27] + -6.666666666666647 * sp[30];
    A[135] = 1.649915822768659 * sp[33] + 3.064129385141734 * sp[34] + -1.649915822768632 * sp[28] + -1.649915822768635 * sp[31] + 0.4714045207910438 * sp[34] + 1.767766952966339 * sp[35] + 5.067598598503611 * sp[29] + -0.2357022603955659 * sp[32] + -5.185449728701379 * sp[28] + -3.889087296526076 * sp[29] + 10.72445284799603 * sp[26] + 4.006938426723748 * sp[27] + -5.185449728701393 * sp[31] + -5.185449728701429 * sp[32] + 17.44196726926825 * sp[27] + 5.892556509887839 * sp[30];
    A[136] = 3.771236166328261 * sp[33] + -3.771236166328256 * sp[34] + 0.9428090415820729 * sp[28] + 0.9428090415820962 * sp[31] + 6.128258770283456 * sp[34] + 1.178511301977638 * sp[35] + -5.421151989096858 * sp[29] + 12.25651754056691 * sp[32] + 3.299831645537238 * sp[28] + -1.649915822768554 * sp[29] + -2.59272486435071 * sp[26] + 3.771236166328307 * sp[27] + 3.299831645537267 * sp[31] + 3.299831645537287 * sp[32] + -8.95668589502964 * sp[27] + 11.78511301977583 * sp[30];
    A[137] = 4.006938426723791 * sp[33] + 10.13519719700722 * sp[34] + -4.006938426723814 * sp[28] + -4.00693842672381 * sp[31] + 5.185449728701376 * sp[34] + 7.660323462854288 * sp[35] + -3.181980515339505 * sp[29] + -16.73486048808172 * sp[32] + -0.4714045207910351 * sp[28] + 2.00346921336187 * sp[29] + 2.474873734152936 * sp[26] + 1.649915822768592 * sp[27] + -0.4714045207910191 * sp[31] + -0.4714045207910296 * sp[32] + 3.299831645537241 * sp[27] + -5.89255650988791 * sp[30];
    A[138] = -7.542472332656575 * sp[33] + -7.77817459305207 * sp[34] + -8.720983634634141 * sp[28] + -7.778174593052062 * sp[31] + -8.720983634634146 * sp[34] + -8.249579113843069 * sp[35] + -12.96362432175344 * sp[29] + -11.07800623858926 * sp[32] + 4.006938426723785 * sp[28] + 4.478342947514835 * sp[29] + -0.2357022603955148 * sp[26] + 0.2357022603955428 * sp[27] + 4.00693842672377 * sp[31] + 4.006938426723806 * sp[32] + 4.00693842672371 * sp[27] + 2.357022603955167 * sp[30];
    A[139] = 8.01387685344759 * sp[33] + 13.19932658214894 * sp[34] + 5.656854249492384 * sp[28] + 13.1993265821489 * sp[31] + 10.37089945740277 * sp[34] + 11.78511301977584 * sp[35] + 11.78511301977581 * sp[29] + 24.51303508113372 * sp[32] + -0.9428090415820658 * sp[28] + 0.4714045207910194 * sp[29] + 0.4714045207910407 * sp[26] + 1.885618083164147 * sp[27] + -0.9428090415820358 * sp[31] + -0.9428090415820602 * sp[32] + -0.942809041582003 * sp[27];
    A[140] = 1.885618083164132 * sp[33] + -5.421151989096869 * sp[34] + 3.064129385141711 * sp[28] + -5.421151989096884 * sp[31] + 3.064129385141729 * sp[34] + -1.178511301977545 * sp[35] + 3.535533905932768 * sp[29] + -13.43502884254441 * sp[32] + 1.649915822768612 * sp[28] + -2.592724864350643 * sp[29] + 2.12132034355964 * sp[26] + -2.121320343559616 * sp[27] + 1.649915822768627 * sp[31] + 1.649915822768639 * sp[32] + 1.64991582276862 * sp[27] + -2.357022603955129 * sp[30];
    A[141] = -4.006938426723782 * sp[33] + -5.185449728701364 * sp[34] + -5.185449728701405 * sp[28] + -5.185449728701391 * sp[31] + -6.835365551469952 * sp[34] + -18.97403196183914 * sp[35] + -4.360491817317076 * sp[29] + -10.84230397819382 * sp[32] + 5.892556509887915 * sp[28] + 5.067598598503553 * sp[29] + 8.36743024404084 * sp[26] + 7.542472332656502 * sp[27] + 9.19238815542511 * sp[31] + 5.421151989096738 * sp[32] + 9.192388155425146 * sp[27] + 5.892556509887847 * sp[30];
    A[142] = 5.656854249492409 * sp[33] + 3.299831645537259 * sp[34] + 3.299831645537255 * sp[28] + 3.29983164553725 * sp[31] + 1.885618083164119 * sp[34] + 2.592724864350729 * sp[35] + -3.06412938514173 * sp[29] + 0.4714045207910975 * sp[32] + -9.42809041582067 * sp[28] + -3.064129385141682 * sp[29] + -14.37783788412653 * sp[26] + -8.013876853447512 * sp[27] + -20.74179891480539 * sp[31] + -8.485281374238484 * sp[32] + -20.74179891480547 * sp[27] + -11.7851130197757 * sp[30];
    A[143] = -1.649915822768638 * sp[33] + -0.4714045207910864 * sp[34] + -0.4714045207910367 * sp[28] + -0.471404520791058 * sp[31] + 4.949747468305816 * sp[34] + -13.08147545195122 * sp[35] + 6.246109900481182 * sp[29] + -6.128258770283488 * sp[32] + 3.535533905932762 * sp[28] + -3.1819805153395 * sp[29] + 4.831896338108113 * sp[26] + -1.885618083164179 * sp[27] + 11.54941075938029 * sp[31] + -11.07800623858926 * sp[32] + 11.54941075938032 * sp[27] + -5.892556509887953 * sp[30];
    A[144] = 26.66666666666692 * sp[33] + 33.33333333333361 * sp[34] + -6.666666666666735 * sp[28] + -6.666666666666652 * sp[31] + 33.33333333333361 * sp[34] + 113.3333333333339 * sp[35] + -6.666666666666599 * sp[29] + 33.3333333333334 * sp[32] + -6.666666666666735 * sp[28] + -6.666666666666599 * sp[29] + 33.33333333333342 * sp[26] + 33.33333333333343 * sp[27] + -6.666666666666652 * sp[31] + 33.3333333333334 * sp[32] + 33.33333333333343 * sp[27] + 66.66666666666653 * sp[30];
    A[145] = 4.082482904638928 * sp[33] + -4.082482904638342 * sp[34] + -28.57738033247069 * sp[28] + -28.5773803324705 * sp[31] + 8.164965809277643 * sp[34] + 14.28869016623524 * sp[35] + -34.70110468942838 * sp[29] + -4.082482904638749 * sp[32] + 8.164965809277193 * sp[28] + 14.28869016623507 * sp[29] + 63.27848502189892 * sp[26] + 69.40220937885684 * sp[27] + 8.164965809276946 * sp[31] + 57.15476066494014 * sp[32] + 57.15476066494102 * sp[27] + 102.0620726159655 * sp[30];
    A[146] = 25.9272486435068 * sp[33] + 16.49915822768602 * sp[34] + -25.92724864350703 * sp[28] + -25.92724864350701 * sp[31] + 37.71236166328271 * sp[34] + -64.81812160876716 * sp[35] + -36.53385036130536 * sp[29] + -124.922198009624 * sp[32] + 9.428090415820671 * sp[28] + 20.03469213361882 * sp[29] + -8.249579113843087 * sp[26] + 2.357022603955095 * sp[27] + 9.42809041582081 * sp[31] + -18.85618083164137 * sp[32] + -18.85618083164138 * sp[27] + -58.92556509887893 * sp[30];
    A[147] = -33.3333333333335 * sp[33] + -26.66666666666681 * sp[34] + 13.33333333333364 * sp[28] + 13.33333333333354 * sp[31] + -46.66666666666698 * sp[34] + -36.66666666666696 * sp[35] + 3.333333333333442 * sp[29] + 13.33333333333333 * sp[32] + -6.666666666666676 * sp[28] + 3.333333333333222 * sp[29] + -36.66666666666681 * sp[26] + -26.66666666666693 * sp[27] + -6.666666666666829 * sp[31] + -6.666666666666845 * sp[32] + -46.66666666666684 * sp[27] + -33.33333333333363 * sp[30];
    A[148] = -36.74234614174805 * sp[33] + -24.49489742783206 * sp[34] + -24.494897427832 * sp[28] + -36.74234614174785 * sp[34] + -30.61862178478967 * sp[35] + -6.123724356958274 * sp[29] + 36.7423461417479 * sp[28] + 42.86607049870597 * sp[29] + -30.61862178478981 * sp[26] + -24.49489742783143 * sp[27] + 36.74234614174788 * sp[31] + 36.74234614174814 * sp[32] + -12.24744871391641 * sp[27] + -36.74234614174696 * sp[30];
    A[149] = -58.92556509887925 * sp[33] + -47.14045207910341 * sp[34] + -18.85618083164116 * sp[28] + -4.714045207910257 * sp[31] + -82.49579113843109 * sp[34] + -64.81812160876736 * sp[35] + -22.39171473757402 * sp[29] + 80.13876853447559 * sp[32] + -11.78511301977579 * sp[28] + 5.892556509887717 * sp[29] + -8.24957911384303 * sp[26] + 9.428090415820508 * sp[27] + -11.78511301977607 * sp[31] + -11.78511301977611 * sp[32] + 16.49915822768595 * sp[27] + 54.21151989096815 * sp[30];
    A[150] = 10.96965511460297 * sp[33] + 0.1443375672973231 * sp[34] + 0.7216878364870799 * sp[28] + 0.7216878364870614 * sp[31] + 0.7216878364869957 * sp[34] + -1.732050807568894 * sp[35] + 11.54700538379251 * sp[29] + 5.051814855409161 * sp[32] + -10.53664241271075 * sp[28] + -8.660254037844515 * sp[29] + 18.47520861406813 * sp[26] + 7.649891066762519 * sp[27] + -10.53664241271076 * sp[31] + -10.5366424127108 * sp[32] + 29.30052616137361 * sp[27] + 10.96965511460281 * sp[30];
    A[151] = -8.9489291724392 * sp[33] + -3.175426480542776 * sp[34] + 1.443375672974011 * sp[28] + 1.443375672973977 * sp[31] + -1.443375672973971 * sp[34] + 2.0207259421637 * sp[35] + -7.216878364870326 * sp[29] + 10.10362971081835 * sp[32] + 3.752776749732583 * sp[28] + -1.443375672973948 * sp[29] + -3.752776749732633 * sp[26] + 4.907477288111897 * sp[27] + 3.752776749732635 * sp[31] + 3.752776749732649 * sp[32] + -12.41303078757702 * sp[27] + 14.14508159514586 * sp[30];
    A[152] = -0.5773502691895829 * sp[33] + 4.474464586219616 * sp[34] + -0.72168783648705 * sp[28] + -0.7216878364870478 * sp[31] + -0.7216878364869734 * sp[34] + 4.04145188432746 * sp[35] + -5.0518148554092 * sp[32] + -3.31976404784037 * sp[28] + -2.886751345948182 * sp[29] + 6.928203230275567 * sp[26] + 6.206515393788464 * sp[27] + -3.319764047840335 * sp[31] + -3.319764047840335 * sp[32] + 7.649891066762587 * sp[27] + -0.5773502691896129 * sp[30];
    A[153] = -5.917840259193766 * sp[33] + -0.8660254037844752 * sp[34] + -11.83568051838749 * sp[28] + -0.8660254037845805 * sp[31] + 0.7216878364869701 * sp[34] + -2.23723229310984 * sp[35] + 18.25870226312177 * sp[29] + 10.96965511460278 * sp[32] + 11.9800180856848 * sp[28] + 13.35122497501018 * sp[29] + 2.670244995002077 * sp[26] + 4.04145188432746 * sp[27] + 11.98001808568476 * sp[31] + 11.9800180856848 * sp[32] + 11.98001808568467 * sp[27] + 8.804591605141816 * sp[30];
    A[154] = -1.154700538379164 * sp[33] + 4.618802153517086 * sp[34] + -5.196152422706527 * sp[28] + 4.618802153517171 * sp[31] + -1.443375672973962 * sp[34] + 5.917840259193765 * sp[35] + -14.8667694316327 * sp[29] + -16.16580753730933 * sp[32] + -6.639528095680735 * sp[28] + -7.938566201357409 * sp[29] + -1.010362971081849 * sp[26] + -2.309401076758502 * sp[27] + -6.639528095680671 * sp[31] + -6.639528095680684 * sp[32] + -6.639528095680604 * sp[27] + -10.39230484541314 * sp[30];
    A[155] = -4.474464586219598 * sp[33] + -3.752776749732468 * sp[34] + -8.948929172439223 * sp[28] + -3.752776749732479 * sp[31] + -0.7216878364869839 * sp[34] + -0.07216878364872875 * sp[35] + 0.2165063509461653 * sp[29] + 5.196152422706618 * sp[32] + 1.876388374866277 * sp[28] + -1.804219591217509 * sp[29] + 1.948557158514979 * sp[26] + -1.732050807568799 * sp[27] + 1.876388374866304 * sp[31] + 1.876388374866305 * sp[32] + 1.876388374866298 * sp[27] + 1.587713240271522 * sp[30];
    A[156] = 2.742413778650664 * sp[33] + 0.7216878364868009 * sp[34] + 0.7216878364870007 * sp[28] + 0.7216878364869603 * sp[31] + 17.89785834487829 * sp[34] + 24.75389279150499 * sp[35] + 2.525907427704572 * sp[29] + 5.051814855409132 * sp[32] + 10.96965511460294 * sp[28] + 9.165435523385273 * sp[29] + 18.11436469582458 * sp[26] + 16.31014510460694 * sp[27] + 19.91858428704208 * sp[31] + 19.34123401785231 * sp[32] + 19.91858428704215 * sp[27] + 17.46484564298614 * sp[30];
    A[157] = 10.39230484541332 * sp[33] + -1.443375672973985 * sp[34] + -1.443375672974093 * sp[28] + -1.443375672974045 * sp[31] + -30.02221399786041 * sp[34] + -19.19689645055489 * sp[35] + -12.26869322027952 * sp[29] + -10.1036297108183 * sp[32] + -16.16580753730961 * sp[28] + -5.340489990004037 * sp[29] + -26.12509968083068 * sp[26] + -15.29978213352506 * sp[27] + -36.95041722813604 * sp[31] + -15.58845726811978 * sp[32] + -36.95041722813616 * sp[27] + -21.93931022920565 * sp[30];
    A[158] = -13.134718624064 * sp[33] + -0.7216878364869126 * sp[34] + -0.721687836486977 * sp[28] + -0.7216878364869546 * sp[31] + 12.12435565298213 * sp[34] + -6.278684177437078 * sp[35] + 9.021097956087914 * sp[29] + -5.051814855409191 * sp[32] + 5.196152422706698 * sp[28] + -4.546633369868337 * sp[29] + 7.289047148519089 * sp[26] + -2.453738644055986 * sp[27] + 17.03183294109399 * sp[31] + -12.41303078757693 * sp[32] + 17.03183294109403 * sp[27] + -7.072540797572987 * sp[30];
    A[159] = 4.082482904638928 * sp[33] + 8.164965809277643 * sp[34] + 8.164965809277193 * sp[28] + 8.164965809276946 * sp[31] + -4.082482904638342 * sp[34] + 14.28869016623524 * sp[35] + 14.28869016623507 * sp[29] + 57.15476066494014 * sp[32] + -28.57738033247069 * sp[28] + -34.70110468942838 * sp[29] + 63.27848502189892 * sp[26] + 57.15476066494102 * sp[27] + -28.5773803324705 * sp[31] + -4.082482904638749 * sp[32] + 69.40220937885684 * sp[27] + 102.0620726159655 * sp[30];
    A[160] = 189.9999999999998 * sp[33] + 57.49999999999886 * sp[34] + 12.49999999999967 * sp[28] + 12.49999999999928 * sp[31] + 57.49999999999886 * sp[34] + 132.4999999999985 * sp[35] + 12.49999999999972 * sp[29] + 87.49999999999888 * sp[32] + 12.49999999999967 * sp[28] + 12.49999999999972 * sp[29] + 132.5000000000003 * sp[26] + 132.5000000000003 * sp[27] + 12.49999999999928 * sp[31] + 87.49999999999888 * sp[32] + 132.5000000000003 * sp[27] + 189.9999999999997 * sp[30];
    A[161] = -31.75426480542928 * sp[33] + 105.3664241271068 * sp[34] + -7.216878364870572 * sp[28] + -7.216878364870528 * sp[31] + -7.216878364869815 * sp[34] + 57.73502691896236 * sp[35] + -28.86751345948149 * sp[29] + -50.5181485540919 * sp[32] + 1.443375672974065 * sp[28] + 23.09401076758503 * sp[29] + 5.773502691896384 * sp[26] + 27.4241377865072 * sp[27] + 1.443375672974337 * sp[31] + 10.1036297108185 * sp[32] + -15.87713240271475 * sp[27] + -31.75426480542911 * sp[30];
    A[162] = 28.57738033247013 * sp[33] + -4.082482904639297 * sp[34] + 69.40220937885704 * sp[28] + -4.082482904638965 * sp[31] + 8.164965809276715 * sp[34] + -22.45365597551277 * sp[35] + -22.45365597551257 * sp[29] + -28.57738033247039 * sp[32] + 8.164965809277376 * sp[28] + 26.53613888015096 * sp[29] + -71.44345083117643 * sp[26] + -53.07227776030278 * sp[27] + 8.164965809277071 * sp[31] + 8.164965809277026 * sp[32] + -89.81462390205024 * sp[27] + -69.40220937885724 * sp[30];
    A[163] = -67.50000000000077 * sp[33] + 7.500000000000064 * sp[34] + 7.499999999998977 * sp[28] + 52.50000000000043 * sp[31] + 3.750000000000016 * sp[35] + 48.74999999999898 * sp[29] + -22.49999999999946 * sp[32] + 90.0000000000006 * sp[28] + 93.75000000000071 * sp[29] + -41.24999999999991 * sp[26] + -37.49999999999931 * sp[27] + 90.00000000000047 * sp[31] + 90.0000000000008 * sp[32] + -30.00000000000066 * sp[27] + -67.49999999999891 * sp[30];
    A[164] = 50.51814855409179 * sp[33] + -7.216878364871487 * sp[34] + 44.74464586219601 * sp[28] + 105.3664241271057 * sp[31] + 14.43375672973965 * sp[34] + -39.69283100678732 * sp[35] + 72.89047148518961 * sp[29] + 62.06515393788339 * sp[32] + 14.43375672974088 * sp[28] + 46.90970937165687 * sp[29] + -13.71206889325356 * sp[26] + 18.76388374866258 * sp[27] + 14.43375672974032 * sp[31] + 14.43375672974024 * sp[32] + 31.75426480542911 * sp[27] + 50.51814855409128 * sp[30];
    A[165] = -6.833333333333353 * sp[33] + 2.416666666666659 * sp[34] + 0.08333333333332088 * sp[28] + 0.08333333333329063 * sp[31] + 1.583333333333382 * sp[34] + 3.749999999999958 * sp[35] + -4.916666666666665 * sp[29] + 0.5833333333333584 * sp[32] + 0.08333333333331305 * sp[28] + -1.249999999999998 * sp[29] + -5.91666666666671 * sp[26] + -0.916666666666632 * sp[27] + 0.08333333333333215 * sp[31] + 0.08333333333338389 * sp[32] + -10.91666666666672 * sp[27] + -1.833333333333267 * sp[30];
    A[166] = 11.16666666666669 * sp[33] + -8.166666666666647 * sp[34] + 3.166666666666695 * sp[28] + 3.166666666666758 * sp[31] + 1.833333333333281 * sp[34] + -16.66666666666659 * sp[35] + 10.66666666666666 * sp[29] + -7.833333333333399 * sp[32] + -5.166666666666704 * sp[28] + 3.333333333333325 * sp[29] + 2.666666666666691 * sp[26] + -4.833333333333407 * sp[27] + -5.166666666666719 * sp[31] + -5.166666666666748 * sp[32] + 10.16666666666669 * sp[27] + -17.16666666666675 * sp[30];
    A[167] = 4.833333333333333 * sp[33] + 14.91666666666666 * sp[34] + -4.083333333333364 * sp[28] + -4.083333333333376 * sp[31] + 2.416666666666647 * sp[34] + 22.91666666666659 * sp[35] + -5.749999999999989 * sp[29] + 11.41666666666674 * sp[32] + -4.083333333333367 * sp[28] + -12.08333333333339 * sp[29] + 3.250000000000036 * sp[26] + 4.916666666666729 * sp[27] + -4.083333333333365 * sp[31] + -4.083333333333343 * sp[32] + 1.583333333333357 * sp[27] + 19.83333333333344 * sp[30];
    A[168] = -3.583333333333337 * sp[33] + -6.999999999999996 * sp[34] + -2.666666666666635 * sp[28] + -6.999999999999959 * sp[31] + -4.916666666666659 * sp[34] + -7.708333333333282 * sp[35] + 4.458333333333303 * sp[29] + 2.166666666666648 * sp[32] + 6.583333333333405 * sp[28] + 7.291666666666704 * sp[29] + 5.45833333333341 * sp[26] + 6.166666666666707 * sp[27] + 6.583333333333393 * sp[31] + 6.583333333333334 * sp[32] + 6.583333333333442 * sp[27] + 6.916666666666687 * sp[30];
    A[169] = 9.666666666666679 * sp[33] + 17.33333333333333 * sp[34] + 6.999999999999958 * sp[28] + 17.33333333333329 * sp[31] + 4.83333333333329 * sp[34] + 24.58333333333325 * sp[35] + -11.41666666666669 * sp[29] + -2.666666666666751 * sp[32] + -8.166666666666739 * sp[28] + -15.41666666666675 * sp[29] + -3.416666666666698 * sp[26] + -10.66666666666673 * sp[27] + -8.166666666666742 * sp[31] + -8.166666666666691 * sp[32] + -8.16666666666673 * sp[27] + -18.00000000000012 * sp[30];
    A[170] = 5.583333333333345 * sp[33] + -10.33333333333332 * sp[34] + 10.6666666666667 * sp[28] + -10.33333333333333 * sp[31] + 0.9166666666666425 * sp[34] + -18.95833333333326 * sp[35] + 4.874999999999947 * sp[29] + 0.5 * sp[32] + -2.583333333333354 * sp[28] + 6.041666666666681 * sp[29] + -4.125000000000017 * sp[26] + 4.500000000000041 * sp[27] + -2.58333333333336 * sp[31] + -2.583333333333382 * sp[32] + -2.583333333333353 * sp[27] + 11.08333333333335 * sp[30];
    A[171] = -1.083333333333305 * sp[33] + -2.416666666666631 * sp[34] + -2.416666666666693 * sp[28] + -2.416666666666685 * sp[31] + 12.16666666666666 * sp[34] + 27.95833333333333 * sp[35] + -2.208333333333327 * sp[29] + 8.083333333333394 * sp[32] + -1.833333333333336 * sp[28] + -2.041666666666619 * sp[29] + 1.791666666666699 * sp[26] + 1.583333333333382 * sp[27] + 2.000000000000015 * sp[31] + 14.33333333333353 * sp[32] + 2.000000000000015 * sp[27] + 9.416666666666789 * sp[30];
    A[172] = -2.000000000000033 * sp[33] + -0.1666666666666444 * sp[34] + -0.1666666666666522 * sp[28] + -0.1666666666666332 * sp[31] + -2.666666666666618 * sp[34] + -8.416666666666615 * sp[35] + 3.583333333333338 * sp[29] + -1.16666666666669 * sp[32] + 5.333333333333343 * sp[28] + 1.583333333333278 * sp[29] + 5.58333333333337 * sp[26] + 1.833333333333291 * sp[27] + 9.333333333333318 * sp[31] + 2.999999999999909 * sp[32] + 9.333333333333382 * sp[27] + 3.666666666666564 * sp[30];
    A[173] = 3.083333333333333 * sp[33] + -1.583333333333446 * sp[34] + -1.583333333333354 * sp[28] + -1.583333333333415 * sp[31] + -9.500000000000046 * sp[34] + 13.37500000000003 * sp[35] + -8.458333333333334 * sp[29] + 3.916666666666713 * sp[32] + -3.500000000000001 * sp[28] + 3.375000000000088 * sp[29] + -4.458333333333372 * sp[26] + 2.416666666666729 * sp[27] + -11.33333333333333 * sp[31] + 17.66666666666675 * sp[32] + -11.33333333333337 * sp[27] + 8.583333333333419 * sp[30];
    A[174] = 25.9272486435068 * sp[33] + 37.71236166328271 * sp[34] + 9.428090415820671 * sp[28] + 9.42809041582081 * sp[31] + 16.49915822768602 * sp[34] + -64.81812160876716 * sp[35] + 20.03469213361882 * sp[29] + -18.85618083164137 * sp[32] + -25.92724864350703 * sp[28] + -36.53385036130536 * sp[29] + -8.249579113843087 * sp[26] + -18.85618083164138 * sp[27] + -25.92724864350701 * sp[31] + -124.922198009624 * sp[32] + 2.357022603955095 * sp[27] + -58.92556509887893 * sp[30];
    A[175] = -31.75426480542928 * sp[33] + -7.216878364869815 * sp[34] + 1.443375672974065 * sp[28] + 1.443375672974337 * sp[31] + 105.3664241271068 * sp[34] + 57.73502691896236 * sp[35] + 23.09401076758503 * sp[29] + 10.1036297108185 * sp[32] + -7.216878364870572 * sp[28] + -28.86751345948149 * sp[29] + 5.773502691896384 * sp[26] + -15.87713240271475 * sp[27] + -7.216878364870528 * sp[31] + -50.5181485540919 * sp[32] + 27.4241377865072 * sp[27] + -31.75426480542911 * sp[30];
    A[176] = 53.3333333333334 * sp[33] + 14.16666666666643 * sp[34] + -30.83333333333352 * sp[28] + -30.83333333333356 * sp[31] + 14.16666666666643 * sp[34] + 219.1666666666667 * sp[35] + -30.83333333333323 * sp[29] + 84.16666666666717 * sp[32] + -30.83333333333352 * sp[28] + -30.83333333333323 * sp[29] + 39.16666666666709 * sp[26] + 39.16666666666706 * sp[27] + -30.83333333333356 * sp[31] + 84.16666666666717 * sp[32] + 39.16666666666706 * sp[27] + 153.333333333334 * sp[30];
    A[177] = -58.92556509887905 * sp[33] + -25.92724864350679 * sp[34] + -40.06938426723772 * sp[28] + 2.357022603955208 * sp[31] + -18.85618083164102 * sp[34] + -22.39171473757398 * sp[35] + 5.89255650988817 * sp[29] + -11.78511301977594 * sp[32] + 37.71236166328285 * sp[28] + 34.17682775735004 * sp[29] + 5.892556509887745 * sp[26] + 2.357022603955093 * sp[27] + 37.71236166328287 * sp[31] + 37.71236166328283 * sp[32] + 9.428090415820549 * sp[27] + -2.3570226039551 * sp[30];
    A[178] = 12.99038105676681 * sp[33] + -4.330127018922191 * sp[34] + -4.33012701892211 * sp[28] + -12.99038105676666 * sp[31] + -25.98076211353322 * sp[34] + 10.82531754730561 * sp[35] + 2.165063509460758 * sp[29] + 12.99038105676641 * sp[32] + 25.98076211353342 * sp[28] + 10.82531754730554 * sp[29] + 36.80607966083907 * sp[26] + 21.65063509461098 * sp[27] + 25.98076211353332 * sp[31] + 25.98076211353299 * sp[32] + -8.660254037843828 * sp[27] + 12.9903810567659 * sp[30];
    A[179] = -104.1666666666668 * sp[33] + -45.8333333333334 * sp[34] + -55.83333333333329 * sp[28] + -0.833333333333222 * sp[31] + -33.33333333333291 * sp[34] + -39.58333333333327 * sp[35] + 5.416666666666908 * sp[29] + -25.83333333333391 * sp[32] + 66.6666666666672 * sp[28] + 60.41666666666708 * sp[29] + 5.416666666666619 * sp[26] + -0.8333333333333766 * sp[27] + 66.66666666666725 * sp[31] + 66.66666666666721 * sp[32] + -3.333333333333245 * sp[27] + -104.1666666666668 * sp[30];
    A[180] = 5.89255650988789 * sp[33] + -3.299831645537225 * sp[34] + 0.4714045207910476 * sp[28] + 0.4714045207910823 * sp[31] + -1.649915822768628 * sp[34] + -2.474873734152917 * sp[35] + -2.003469213361912 * sp[29] + 0.4714045207910431 * sp[32] + 16.73486048808173 * sp[28] + 3.181980515339537 * sp[29] + -7.660323462854306 * sp[26] + -5.185449728701299 * sp[27] + 4.006938426723815 * sp[31] + 4.006938426723851 * sp[32] + -10.1351971970073 * sp[27] + -4.006938426723782 * sp[30];
    A[181] = -11.78511301977582 * sp[33] + 8.956685895029585 * sp[34] + -3.299831645537249 * sp[28] + -3.299831645537319 * sp[31] + -3.771236166328268 * sp[34] + 2.592724864350691 * sp[35] + 1.649915822768607 * sp[29] + -3.299831645537283 * sp[32] + -12.25651754056686 * sp[28] + 5.421151989096812 * sp[29] + -1.178511301977577 * sp[26] + -6.128258770283507 * sp[27] + -0.942809041582066 * sp[31] + -0.9428090415820995 * sp[32] + 3.771236166328305 * sp[27] + -3.771236166328316 * sp[30];
    A[182] = -5.892556509887906 * sp[33] + -17.44196726926819 * sp[34] + 5.185449728701395 * sp[28] + 5.185449728701407 * sp[31] + -4.00693842672378 * sp[34] + -10.724452847996 * sp[35] + 3.88908729652603 * sp[29] + 5.185449728701389 * sp[32] + 0.2357022603955463 * sp[28] + -5.067598598503528 * sp[29] + -1.767766952966403 * sp[26] + -0.4714045207910229 * sp[27] + 1.649915822768631 * sp[31] + 1.649915822768641 * sp[32] + -3.064129385141758 * sp[27] + -1.649915822768606 * sp[30];
    A[183] = 5.892556509887934 * sp[33] + 9.192388155425137 * sp[34] + 5.421151989096883 * sp[28] + 9.192388155425107 * sp[31] + 7.542472332656537 * sp[34] + 8.367430244040808 * sp[35] + 5.067598598503643 * sp[29] + 5.892556509887909 * sp[32] + -10.84230397819382 * sp[28] + -4.360491817317126 * sp[29] + -18.9740319618391 * sp[26] + -6.835365551470073 * sp[27] + -5.185449728701407 * sp[31] + -5.185449728701429 * sp[32] + -5.185449728701351 * sp[27] + -4.006938426723819 * sp[30];
    A[184] = -11.78511301977583 * sp[33] + -20.74179891480541 * sp[34] + -8.485281374238545 * sp[28] + -20.74179891480538 * sp[31] + -8.013876853447565 * sp[34] + -14.37783788412649 * sp[35] + -3.064129385141709 * sp[29] + -9.428090415820671 * sp[32] + 0.4714045207910904 * sp[28] + -3.064129385141614 * sp[29] + 2.592724864350711 * sp[26] + 1.88561808316418 * sp[27] + 3.299831645537263 * sp[31] + 3.299831645537273 * sp[32] + 3.299831645537225 * sp[27] + 5.656854249492359 * sp[30];
    A[185] = -5.892556509887909 * sp[33] + 11.54941075938026 * sp[34] + -11.07800623858927 * sp[28] + 11.54941075938029 * sp[31] + -1.885618083164137 * sp[34] + 4.831896338108094 * sp[35] + -3.181980515339467 * sp[29] + 3.535533905932804 * sp[32] + -6.128258770283416 * sp[28] + 6.246109900481125 * sp[29] + -13.08147545195115 * sp[26] + 4.949747468305797 * sp[27] + -0.4714045207910277 * sp[31] + -0.4714045207910498 * sp[32] + -0.4714045207910118 * sp[27] + -1.649915822768606 * sp[30];
    A[186] = 2.357022603955147 * sp[33] + 4.00693842672376 * sp[34] + 4.006938426723815 * sp[28] + 4.006938426723807 * sp[31] + 0.2357022603954988 * sp[34] + -0.2357022603954801 * sp[35] + 4.4783429475148 * sp[29] + 4.006938426723782 * sp[32] + -11.07800623858928 * sp[28] + -12.96362432175339 * sp[29] + -8.249579113843112 * sp[26] + -8.720983634634102 * sp[27] + -7.778174593052077 * sp[31] + -8.720983634634065 * sp[32] + -7.778174593052119 * sp[27] + -7.54247233265655 * sp[30];
    A[187] = -0.9428090415821101 * sp[34] + -0.9428090415820871 * sp[28] + -0.9428090415821091 * sp[31] + 1.885618083164121 * sp[34] + 0.4714045207910074 * sp[35] + 0.4714045207910695 * sp[29] + -0.9428090415820647 * sp[32] + 24.5130350811337 * sp[28] + 11.78511301977577 * sp[29] + 11.78511301977584 * sp[26] + 10.37089945740265 * sp[27] + 13.19932658214896 * sp[31] + 5.656854249492396 * sp[32] + 13.19932658214903 * sp[27] + 8.01387685344757 * sp[30];
    A[188] = -2.357022603955141 * sp[33] + 1.649915822768738 * sp[34] + 1.649915822768629 * sp[28] + 1.649915822768697 * sp[31] + -2.121320343559613 * sp[34] + 2.121320343559725 * sp[35] + -2.592724864350686 * sp[29] + 1.649915822768657 * sp[32] + -13.43502884254444 * sp[28] + 3.535533905932831 * sp[29] + -1.178511301977582 * sp[26] + 3.064129385141805 * sp[27] + -5.42115198909689 * sp[31] + 3.06412938514175 * sp[32] + -5.421151989096927 * sp[27] + 1.885618083164176 * sp[30];
    A[189] = -33.3333333333335 * sp[33] + -46.66666666666698 * sp[34] + -6.666666666666676 * sp[28] + -6.666666666666829 * sp[31] + -26.66666666666681 * sp[34] + -36.66666666666696 * sp[35] + 3.333333333333222 * sp[29] + -6.666666666666845 * sp[32] + 13.33333333333364 * sp[28] + 3.333333333333442 * sp[29] + -36.66666666666681 * sp[26] + -46.66666666666684 * sp[27] + 13.33333333333354 * sp[31] + 13.33333333333333 * sp[32] + -26.66666666666693 * sp[27] + -33.33333333333363 * sp[30];
    A[190] = 28.57738033247013 * sp[33] + 8.164965809276715 * sp[34] + 8.164965809277376 * sp[28] + 8.164965809277071 * sp[31] + -4.082482904639297 * sp[34] + -22.45365597551277 * sp[35] + 26.53613888015096 * sp[29] + 8.164965809277026 * sp[32] + 69.40220937885704 * sp[28] + -22.45365597551257 * sp[29] + -71.44345083117643 * sp[26] + -89.81462390205024 * sp[27] + -4.082482904638965 * sp[31] + -28.57738033247039 * sp[32] + -53.07227776030278 * sp[27] + -69.40220937885724 * sp[30];
    A[191] = -58.92556509887905 * sp[33] + -18.85618083164102 * sp[34] + 37.71236166328285 * sp[28] + 37.71236166328287 * sp[31] + -25.92724864350679 * sp[34] + -22.39171473757398 * sp[35] + 34.17682775735004 * sp[29] + 37.71236166328283 * sp[32] + -40.06938426723772 * sp[28] + 5.89255650988817 * sp[29] + 5.892556509887745 * sp[26] + 9.428090415820549 * sp[27] + 2.357022603955208 * sp[31] + -11.78511301977594 * sp[32] + 2.357022603955093 * sp[27] + -2.3570226039551 * sp[30];
    A[192] = 66.66666666666683 * sp[33] + 33.33333333333346 * sp[34] + 33.33333333333319 * sp[28] + -6.666666666666801 * sp[31] + 33.33333333333346 * sp[34] + 33.33333333333334 * sp[35] + -6.666666666666798 * sp[29] + -6.666666666666719 * sp[32] + 33.33333333333319 * sp[28] + -6.666666666666798 * sp[29] + 113.3333333333337 * sp[26] + 33.33333333333361 * sp[27] + -6.666666666666801 * sp[31] + -6.666666666666719 * sp[32] + 33.33333333333361 * sp[27] + 26.66666666666708 * sp[30];
    A[193] = 12.247448713916 * sp[34] + 12.24744871391598 * sp[28] + 12.24744871391601 * sp[31] + 36.74234614174777 * sp[34] + 24.49489742783172 * sp[35] + 24.49489742783186 * sp[29] + 12.24744871391584 * sp[32] + -110.2270384252439 * sp[28] + -48.98979485566404 * sp[29] + -48.98979485566376 * sp[26] + 36.74234614174728 * sp[27] + -36.74234614174809 * sp[31] + -36.7423461417483 * sp[32] + 12.24744871391588 * sp[27] + 24.49489742783136 * sp[30];
    A[194] = 117.8511301977582 * sp[33] + 58.92556509887915 * sp[34] + 58.9255650988789 * sp[28] + 2.357022603955026 * sp[31] + 58.92556509887917 * sp[34] + 58.92556509887896 * sp[35] + 2.357022603955114 * sp[29] + 2.357022603954603 * sp[32] + 58.92556509887871 * sp[28] + -11.78511301977601 * sp[29] + 44.78342947514811 * sp[26] + -11.78511301977576 * sp[27] + -11.78511301977603 * sp[31] + -11.78511301977589 * sp[32] + -11.78511301977586 * sp[27] + -9.428090415821012 * sp[30];
    A[195] = -16.88749537379672 * sp[33] + -5.196152422706707 * sp[34] + 5.19615242270667 * sp[28] + 5.196152422706616 * sp[31] + -7.361215932167807 * sp[34] + -6.278684177437302 * sp[35] + 11.9078493020362 * sp[29] + 5.196152422706657 * sp[32] + -7.361215932167788 * sp[28] + 4.979646071760513 * sp[29] + -21.8671414455572 * sp[26] + -1.732050807568872 * sp[27] + 3.897114317029946 * sp[31] + 3.897114317029911 * sp[32] + -15.15544456622755 * sp[27] + -3.897114317029861 * sp[30];
    A[196] = 7.794228634060024 * sp[33] + -2.598076211353306 * sp[34] + 2.598076211353332 * sp[28] + 2.598076211353385 * sp[31] + 1.732050807568895 * sp[34] + -0.4330127018921406 * sp[35] + -2.165063509461177 * sp[29] + 2.598076211353414 * sp[32] + 1.73205080756889 * sp[28] + -5.629165124598799 * sp[29] + 13.42339375865889 * sp[26] + -0.8660254037845787 * sp[27] + -3.464101615137761 * sp[31] + -3.464101615137675 * sp[32] + 8.660254037844338 * sp[27] + -5.196152422706558 * sp[30];
    A[197] = -3.897114317029999 * sp[33] + -5.196152422706646 * sp[34] + 5.196152422706676 * sp[28] + 5.196152422706643 * sp[31] + -3.031088913245559 * sp[34] + -4.11362066797612 * sp[35] + 5.412658773652808 * sp[29] + 5.196152422706614 * sp[32] + -3.031088913245549 * sp[28] + -1.515544456622838 * sp[29] + -2.3815698604072 * sp[26] + -1.7320508075688 * sp[27] + -0.4330127018922432 * sp[31] + -0.4330127018922776 * sp[32] + -2.165063509461061 * sp[27] + 0.4330127018921672 * sp[30];
    A[198] = 16.88749537379668 * sp[33] + 11.69134295109 * sp[34] + 22.0836477965033 * sp[28] + 11.69134295109002 * sp[31] + 9.526279441628903 * sp[34] + 10.60881119635947 * sp[35] + 2.814582562299452 * sp[29] + 3.897114317030031 * sp[32] + 9.526279441628887 * sp[28] + -0.649519052838297 * sp[29] + 36.58957330989249 * sp[26] + 19.48557158514985 * sp[27] + -1.732050807568816 * sp[31] + -1.732050807568815 * sp[32] + -1.732050807568839 * sp[27] + 0.4330127018922303 * sp[30];
    A[199] = -7.794228634060001 * sp[33] + -10.39230484541331 * sp[34] + -5.196152422706646 * sp[28] + -10.39230484541325 * sp[31] + -6.062177826491114 * sp[34] + -8.227241335952217 * sp[35] + -1.299038105676658 * sp[29] + -3.464101615137726 * sp[32] + -6.062177826491114 * sp[28] + -3.031088913245621 * sp[29] + -16.88749537379651 * sp[26] + -17.32050807568874 * sp[27] + -0.8660254037844857 * sp[31] + -0.8660254037845029 * sp[32] + -0.8660254037844718 * sp[27] + 3.464101615137757 * sp[30];
    A[200] = 3.897114317029998 * sp[33] + -1.29903810567666 * sp[34] + 9.093266739736679 * sp[28] + -1.299038105676647 * sp[31] + 0.8660254037844368 * sp[34] + -0.2165063509460685 * sp[35] + 0.6495190528383197 * sp[29] + -0.4330127018921908 * sp[32] + 0.8660254037844447 * sp[28] + -2.814582562299359 * sp[29] + 8.443747686898307 * sp[26] + -2.165063509461031 * sp[27] + -1.732050807568878 * sp[31] + -1.732050807568807 * sp[32] + -1.732050807568878 * sp[27] + -3.897114317029976 * sp[30];
    A[201] = 10.3923048454133 * sp[33] + 11.69134295108997 * sp[34] + 11.69134295109001 * sp[28] + 11.69134295108997 * sp[31] + 7.361215932167804 * sp[34] + 6.062177826491064 * sp[35] + 12.9903810567667 * sp[29] + 11.69134295108998 * sp[32] + 7.361215932167632 * sp[28] + 12.99038105676648 * sp[29] + -7.79422863405994 * sp[26] + -3.897114317029977 * sp[27] + -6.495190528383207 * sp[31] + -8.227241335952147 * sp[32] + -6.495190528383184 * sp[27] + -6.062177826490993 * sp[30];
    A[202] = -20.78460969082662 * sp[33] + -10.3923048454133 * sp[34] + -10.39230484541332 * sp[28] + -10.39230484541326 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137791 * sp[35] + -17.32050807568897 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541311 * sp[28] + -17.32050807568872 * sp[29] + 24.24871130596439 * sp[26] + 3.464101615137783 * sp[27] + 17.3205080756886 * sp[31] + 3.464101615137627 * sp[32] + 17.3205080756886 * sp[27] + 7.794228634059758 * sp[30];
    A[203] = 10.39230484541334 * sp[33] + -1.299038105676697 * sp[34] + -1.299038105676672 * sp[28] + -1.299038105676725 * sp[31] + 3.031088913245607 * sp[34] + -2.598076211353377 * sp[35] + 4.330127018922287 * sp[29] + -1.299038105676729 * sp[32] + 3.031088913245486 * sp[28] + 4.33012701892232 * sp[29] + -16.45448267190443 * sp[26] + 0.4330127018923184 * sp[27] + -10.82531754730541 * sp[31] + 4.763139720814346 * sp[32] + -10.82531754730541 * sp[27] + 2.598076211353316 * sp[30];
    A[204] = -36.74234614174805 * sp[33] + -36.74234614174785 * sp[34] + 36.7423461417479 * sp[28] + 36.74234614174788 * sp[31] + -24.49489742783206 * sp[34] + -30.61862178478967 * sp[35] + 42.86607049870597 * sp[29] + 36.74234614174814 * sp[32] + -24.494897427832 * sp[28] + -6.123724356958274 * sp[29] + -30.61862178478981 * sp[26] + -12.24744871391641 * sp[27] + -24.49489742783143 * sp[27] + -36.74234614174696 * sp[30];
    A[205] = -67.50000000000077 * sp[33] + 90.0000000000006 * sp[28] + 90.00000000000047 * sp[31] + 7.500000000000064 * sp[34] + 3.750000000000016 * sp[35] + 93.75000000000071 * sp[29] + 90.0000000000008 * sp[32] + 7.499999999998977 * sp[28] + 48.74999999999898 * sp[29] + -41.24999999999991 * sp[26] + -30.00000000000066 * sp[27] + 52.50000000000043 * sp[31] + -22.49999999999946 * sp[32] + -37.49999999999931 * sp[27] + -67.49999999999891 * sp[30];
    A[206] = 12.99038105676681 * sp[33] + -25.98076211353322 * sp[34] + 25.98076211353342 * sp[28] + 25.98076211353332 * sp[31] + -4.330127018922191 * sp[34] + 10.82531754730561 * sp[35] + 10.82531754730554 * sp[29] + 25.98076211353299 * sp[32] + -4.33012701892211 * sp[28] + 2.165063509460758 * sp[29] + 36.80607966083907 * sp[26] + -8.660254037843828 * sp[27] + -12.99038105676666 * sp[31] + 12.99038105676641 * sp[32] + 21.65063509461098 * sp[27] + 12.9903810567659 * sp[30];
    A[207] = 36.74234614174777 * sp[34] + -110.2270384252439 * sp[28] + -36.74234614174809 * sp[31] + 12.247448713916 * sp[34] + 24.49489742783172 * sp[35] + -48.98979485566404 * sp[29] + -36.7423461417483 * sp[32] + 12.24744871391598 * sp[28] + 24.49489742783186 * sp[29] + -48.98979485566376 * sp[26] + 12.24744871391588 * sp[27] + 12.24744871391601 * sp[31] + 12.24744871391584 * sp[32] + 36.74234614174728 * sp[27] + 24.49489742783136 * sp[30];
    A[208] = 135.0000000000012 * sp[33] + 67.50000000000063 * sp[34] + 67.50000000000043 * sp[28] + -22.49999999999968 * sp[31] + 67.50000000000063 * sp[34] + 67.50000000000082 * sp[35] + -22.50000000000006 * sp[29] + -22.49999999999964 * sp[32] + 67.50000000000043 * sp[28] + -22.50000000000006 * sp[29] + 247.4999999999997 * sp[26] + 67.50000000000013 * sp[27] + -22.49999999999968 * sp[31] + -22.49999999999964 * sp[32] + 67.50000000000013 * sp[27] + 59.99999999999963 * sp[30];
    A[209] = 64.95190528383307 * sp[34] + -38.97114317030021 * sp[28] + 12.99038105676645 * sp[31] + 21.65063509461118 * sp[34] + 43.30127018922184 * sp[35] + -8.660254037844322 * sp[29] + 12.99038105676678 * sp[32] + 21.65063509461106 * sp[28] + 43.30127018922204 * sp[29] + -8.660254037845011 * sp[26] + 99.59292143520955 * sp[27] + 21.65063509461118 * sp[31] + 21.65063509461088 * sp[32] + -12.99038105676642 * sp[27] + 43.3012701892228 * sp[30];
    A[210] = 10.41666666666666 * sp[33] + -5.833333333333339 * sp[34] + 0.8333333333333677 * sp[28] + 0.8333333333334234 * sp[31] + -2.916666666666698 * sp[34] + -4.375000000000002 * sp[35] + -3.541666666666713 * sp[29] + 0.8333333333333535 * sp[32] + 10.08333333333337 * sp[28] + -2.874999999999999 * sp[29] + 7.958333333333433 * sp[26] + 1.833333333333369 * sp[27] + -1.416666666666664 * sp[31] + -1.416666666666789 * sp[32] + 3.58333333333334 * sp[27] + 2.916666666666623 * sp[30];
    A[211] = -20.83333333333339 * sp[33] + 15.8333333333333 * sp[34] + -5.833333333333382 * sp[28] + -5.833333333333505 * sp[31] + -6.666666666666689 * sp[34] + 4.583333333333361 * sp[35] + 2.916666666666662 * sp[29] + -5.833333333333442 * sp[32] + -12.66666666666668 * sp[28] + 11.5833333333333 * sp[29] + -10.08333333333342 * sp[26] + 2.166666666666594 * sp[27] + 0.3333333333333488 * sp[31] + 0.3333333333335808 * sp[32] + -1.333333333333362 * sp[27] + 13.33333333333328 * sp[30];
    A[212] = -10.41666666666668 * sp[33] + -30.83333333333335 * sp[34] + 9.16666666666675 * sp[28] + 9.166666666666771 * sp[31] + -7.083333333333352 * sp[34] + -18.95833333333337 * sp[35] + 6.875000000000032 * sp[29] + 9.166666666666741 * sp[32] + -4.083333333333309 * sp[28] + -12.45833333333329 * sp[29] + 3.375000000000036 * sp[26] + 0.1666666666666887 * sp[27] + -0.5833333333333179 * sp[31] + -0.5833333333334191 * sp[32] + 1.083333333333331 * sp[27] + -12.91666666666669 * sp[30];
    A[213] = 10.41666666666673 * sp[33] + 16.25000000000003 * sp[34] + 9.583333333333346 * sp[28] + 16.24999999999997 * sp[31] + 13.33333333333338 * sp[34] + 14.79166666666666 * sp[35] + 8.958333333333419 * sp[29] + 10.41666666666668 * sp[32] + 0.3333333333332962 * sp[28] + 3.291666666666655 * sp[29] + 7.458333333333224 * sp[26] + 9.41666666666659 * sp[27] + 1.833333333333302 * sp[31] + 1.833333333333351 * sp[32] + 1.83333333333326 * sp[27] + 2.916666666666641 * sp[30];
    A[214] = -20.83333333333339 * sp[33] + -36.66666666666671 * sp[34] + -14.99999999999994 * sp[28] + -36.66666666666663 * sp[31] + -14.16666666666671 * sp[34] + -25.41666666666669 * sp[35] + -5.416666666666667 * sp[29] + -16.66666666666672 * sp[32] + -8.166666666666639 * sp[28] + -12.41666666666663 * sp[29] + -12.41666666666658 * sp[26] + -24.66666666666656 * sp[27] + -1.166666666666628 * sp[31] + -1.166666666666712 * sp[32] + -1.166666666666599 * sp[27] + 10.00000000000006 * sp[30];
    A[215] = -10.41666666666669 * sp[33] + 20.41666666666664 * sp[34] + -19.58333333333339 * sp[28] + 20.41666666666669 * sp[31] + -3.333333333333351 * sp[34] + 8.541666666666698 * sp[35] + -5.625000000000004 * sp[29] + 6.250000000000114 * sp[32] + -6.333333333333336 * sp[28] + 12.04166666666663 * sp[29] + -12.12500000000005 * sp[26] + 15.24999999999996 * sp[27] + 0.1666666666666692 * sp[31] + 0.1666666666668544 * sp[32] + 0.1666666666666645 * sp[27] + -12.91666666666647 * sp[30];
    A[216] = 4.166666666666642 * sp[33] + 7.083333333333307 * sp[34] + 7.083333333333419 * sp[28] + 7.083333333333401 * sp[31] + 0.416666666666635 * sp[34] + -0.4166666666666083 * sp[35] + 7.916666666666668 * sp[29] + 7.08333333333336 * sp[32] + 8.416666666666643 * sp[28] + 13.58333333333325 * sp[29] + 1.916666666666708 * sp[26] + 3.083333333333333 * sp[27] + 2.749999999999941 * sp[31] + -8.916666666666913 * sp[32] + 2.749999999999976 * sp[27] + -3.333333333333458 * sp[30];
    A[217] = -1.666666666666742 * sp[34] + -1.666666666666716 * sp[28] + -1.666666666666749 * sp[31] + 3.333333333333329 * sp[34] + 0.8333333333332931 * sp[35] + 0.8333333333333979 * sp[29] + -1.66666666666667 * sp[32] + -12.66666666666665 * sp[28] + -7.166666666666653 * sp[29] + -7.166666666666774 * sp[26] + -3.666666666666684 * sp[27] + -4.666666666666631 * sp[31] + -7.999999999999895 * sp[32] + -4.666666666666654 * sp[27] + -5.833333333333214 * sp[30];
    A[218] = -4.16666666666664 * sp[33] + 2.91666666666689 * sp[34] + 2.916666666666702 * sp[28] + 2.916666666666819 * sp[31] + -3.74999999999995 * sp[34] + 3.750000000000146 * sp[35] + -4.583333333333354 * sp[29] + 2.91666666666675 * sp[32] + 4.250000000000016 * sp[28] + -2.249999999999912 * sp[29] + 9.416666666666766 * sp[26] + -1.08333333333327 * sp[27] + 1.91666666666668 * sp[31] + -13.08333333333324 * sp[32] + 1.916666666666692 * sp[27] + -6.666666666666647 * sp[30];
    A[219] = -58.92556509887925 * sp[33] + -82.49579113843109 * sp[34] + -11.78511301977579 * sp[28] + -11.78511301977607 * sp[31] + -47.14045207910341 * sp[34] + -64.81812160876736 * sp[35] + 5.892556509887717 * sp[29] + -11.78511301977611 * sp[32] + -18.85618083164116 * sp[28] + -22.39171473757402 * sp[29] + -8.24957911384303 * sp[26] + 16.49915822768595 * sp[27] + -4.714045207910257 * sp[31] + 80.13876853447559 * sp[32] + 9.428090415820508 * sp[27] + 54.21151989096815 * sp[30];
    A[220] = 50.51814855409179 * sp[33] + 14.43375672973965 * sp[34] + 14.43375672974088 * sp[28] + 14.43375672974032 * sp[31] + -7.216878364871487 * sp[34] + -39.69283100678732 * sp[35] + 46.90970937165687 * sp[29] + 14.43375672974024 * sp[32] + 44.74464586219601 * sp[28] + 72.89047148518961 * sp[29] + -13.71206889325356 * sp[26] + 31.75426480542911 * sp[27] + 105.3664241271057 * sp[31] + 62.06515393788339 * sp[32] + 18.76388374866258 * sp[27] + 50.51814855409128 * sp[30];
    A[221] = -104.1666666666668 * sp[33] + -33.33333333333291 * sp[34] + 66.6666666666672 * sp[28] + 66.66666666666725 * sp[31] + -45.8333333333334 * sp[34] + -39.58333333333327 * sp[35] + 60.41666666666708 * sp[29] + 66.66666666666721 * sp[32] + -55.83333333333329 * sp[28] + 5.416666666666908 * sp[29] + 5.416666666666619 * sp[26] + -3.333333333333245 * sp[27] + -0.833333333333222 * sp[31] + -25.83333333333391 * sp[32] + -0.8333333333333766 * sp[27] + -104.1666666666668 * sp[30];
    A[222] = 117.8511301977582 * sp[33] + 58.92556509887917 * sp[34] + 58.92556509887871 * sp[28] + -11.78511301977603 * sp[31] + 58.92556509887915 * sp[34] + 58.92556509887896 * sp[35] + -11.78511301977601 * sp[29] + -11.78511301977589 * sp[32] + 58.9255650988789 * sp[28] + 2.357022603955114 * sp[29] + 44.78342947514811 * sp[26] + -11.78511301977586 * sp[27] + 2.357022603955026 * sp[31] + 2.357022603954603 * sp[32] + -11.78511301977576 * sp[27] + -9.428090415821012 * sp[30];
    A[223] = 21.65063509461118 * sp[34] + 21.65063509461106 * sp[28] + 21.65063509461118 * sp[31] + 64.95190528383307 * sp[34] + 43.30127018922184 * sp[35] + 43.30127018922204 * sp[29] + 21.65063509461088 * sp[32] + -38.97114317030021 * sp[28] + -8.660254037844322 * sp[29] + -8.660254037845011 * sp[26] + -12.99038105676642 * sp[27] + 12.99038105676645 * sp[31] + 12.99038105676678 * sp[32] + 99.59292143520955 * sp[27] + 43.3012701892228 * sp[30];
    A[224] = 208.3333333333338 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666665 * sp[28] + 4.166666666666435 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666667 * sp[35] + 4.166666666666556 * sp[29] + 4.166666666665677 * sp[32] + 104.1666666666665 * sp[28] + 4.166666666666556 * sp[29] + 104.1666666666667 * sp[26] + 4.166666666666572 * sp[27] + 4.166666666666435 * sp[31] + 4.166666666665677 * sp[32] + 4.166666666666572 * sp[27] + 183.3333333333319 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698437 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.05734126984127029 * sp[17];
    A[1] = -0.02986111111111125 * sp[19] + 0.00595238095238089 * sp[18] + 0.009920634920634986 * sp[18] + -0.04871031746031777 * sp[17];
    A[2] = 0.0176587301587301 * sp[19] + -0.004712301587301548 * sp[18] + -0.004712301587301586 * sp[18] + 0.01765873015873018 * sp[17];
    A[3] = -0.0154265873015874 * sp[19] + -0.0244791666666668 * sp[18] + 0.009052579365079369 * sp[18] + 0.01860119047619061 * sp[17];
    A[4] = 0.01746031746031738 * sp[19] + 0.02167658730158715 * sp[18] + -0.005704365079365067 * sp[18] + -0.01190476190476188 * sp[17];
    A[5] = -0.02385912698412701 * sp[19] + -0.03266369047619058 * sp[18] + 0.006820436507936537 * sp[18] + 0.01116071428571419 * sp[17];
    A[6] = -0.01314484126984128 * sp[19] + -0.008804563492063535 * sp[18] + 0.03067956349206365 * sp[18] + 0.02385912698412708 * sp[17];
    A[7] = 0.02777777777777799 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285772 * sp[18] + -0.06111111111111162 * sp[17];
    A[8] = -0.02058531746031762 * sp[19] + -0.007068452380952371 * sp[18] + 0.05820932539682571 * sp[18] + 0.05114087301587342 * sp[17];
    A[9] = 0.04349267900155106 * sp[19] + -0.02314932914598859 * sp[18] + -0.06243303921190632 * sp[18] + 0.03507474113028557 * sp[17];
    A[10] = 0.06529556615835221 * sp[19] + -0.05154913117764581 * sp[18] + -0.1271545235715238 * sp[18] + 0.06529556615835085 * sp[17];
    A[11] = -0.0168650793650814 * sp[19] + -0.007440476190475747 * sp[18] + 0.07192460317460277 * sp[18] + -0.0109126984126997 * sp[17];
    A[12] = 0.03507474113028576 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429705 * sp[18] + -0.1248660784238148 * sp[17];
    A[13] = -0.1005208057964096 * sp[19] + -0.06314768569261574 * sp[18] + 0.07088005536926235 * sp[18] + -0.08505606644311357 * sp[17];
    A[14] = 0.06200396825396943 * sp[19] + 0.09598214285714192 * sp[18] + -0.0210813492063494 * sp[18] + 0.05307539682539857 * sp[17];
    A[15] = -0.02986111111111125 * sp[19] + 0.009920634920634986 * sp[18] + 0.00595238095238089 * sp[18] + -0.04871031746031777 * sp[17];
    A[16] = 0.06865079365079403 * sp[19] + -0.01289682539682548 * sp[18] + -0.01289682539682548 * sp[18] + 0.06865079365079425 * sp[17];
    A[17] = -0.04871031746031758 * sp[19] + 0.00595238095238087 * sp[18] + 0.009920634920634996 * sp[18] + -0.02986111111111131 * sp[17];
    A[18] = 0.01746031746031737 * sp[19] + 0.02316468253968249 * sp[18] + -0.004216269841269746 * sp[18] + -0.01041666666666663 * sp[17];
    A[19] = -0.04384920634920631 * sp[19] + -0.05327380952380961 * sp[18] + 0.009424603174603186 * sp[18] + 0.01785714285714287 * sp[17];
    A[20] = 0.06111111111111138 * sp[19] + 0.07524801587301631 * sp[18] + -0.01165674603174612 * sp[18] + -0.02529761904761915 * sp[17];
    A[21] = 0.01041666666666667 * sp[19] + 0.004216269841269756 * sp[18] + -0.02316468253968255 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.01785714285714302 * sp[19] + -0.009424603174603228 * sp[18] + 0.05327380952380981 * sp[18] + 0.04384920634920658 * sp[17];
    A[23] = 0.02529761904761936 * sp[19] + 0.01165674603174616 * sp[18] + -0.07524801587301651 * sp[18] + -0.06111111111111168 * sp[17];
    A[24] = -0.07856742013183721 * sp[19] + -0.009820927516479953 * sp[18] + 0.1360899955855055 * sp[18] + 0.07014948226057133 * sp[17];
    A[25] = -0.05326743555023493 * sp[19] + -0.008591521862941652 * sp[18] + 0.1838585678669348 * sp[18] + 0.08419691425682242 * sp[17];
    A[26] = -0.004960317460314351 * sp[19] + 0.01984126984126908 * sp[18] + -0.162698412698412 * sp[18] + -0.1021825396825402 * sp[17];
    A[27] = -0.07014948226057144 * sp[19] + -0.1360899955855055 * sp[18] + 0.009820927516479908 * sp[18] + 0.07856742013183715 * sp[17];
    A[28] = 0.04639421805988044 * sp[19] + 0.04897167461876219 * sp[18] + -0.01288728279441046 * sp[18] + 0.0309294787065859 * sp[17];
    A[29] = -0.1240079365079387 * sp[19] + -0.2405753968253961 * sp[18] + 0.01736111111111123 * sp[18] + 0.04365079365079525 * sp[17];
    A[30] = 0.0176587301587301 * sp[19] + -0.004712301587301586 * sp[18] + -0.004712301587301548 * sp[18] + 0.01765873015873018 * sp[17];
    A[31] = -0.04871031746031758 * sp[19] + 0.009920634920634996 * sp[18] + 0.00595238095238087 * sp[18] + -0.02986111111111131 * sp[17];
    A[32] = 0.05734126984127017 * sp[19] + -0.01116071428571433 * sp[18] + -0.01116071428571433 * sp[18] + 0.02162698412698435 * sp[17];
    A[33] = -0.02385912698412702 * sp[19] + -0.03067956349206362 * sp[18] + 0.00880456349206353 * sp[18] + 0.01314484126984127 * sp[17];
    A[34] = 0.06111111111111146 * sp[19] + 0.07276785714285766 * sp[18] + -0.01413690476190483 * sp[18] + -0.02777777777777794 * sp[17];
    A[35] = -0.0511408730158732 * sp[19] + -0.05820932539682566 * sp[18] + 0.007068452380952334 * sp[18] + 0.02058531746031753 * sp[17];
    A[36] = -0.01860119047619066 * sp[19] + -0.009052579365079394 * sp[18] + 0.02447916666666682 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.011904761904762 * sp[19] + 0.005704365079365083 * sp[18] + -0.02167658730158726 * sp[18] + -0.01746031746031749 * sp[17];
    A[38] = -0.01116071428571439 * sp[19] + -0.006820436507936581 * sp[18] + 0.03266369047619067 * sp[18] + 0.02385912698412714 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429718 * sp[18] + -0.1283735525368425 * sp[18] + -0.03507474113028566 * sp[17];
    A[40] = -0.003436608745177509 * sp[19] + -0.0171830437258813 * sp[18] + -0.0515491311776443 * sp[18] + -0.003436608745176609 * sp[17];
    A[41] = 0.1001984126984117 * sp[19] + -0.07192460317460359 * sp[18] + 0.1026785714285716 * sp[18] + 0.1180555555555571 * sp[17];
    A[42] = -0.03507474113028564 * sp[19] + 0.06243303921190642 * sp[18] + 0.02314932914598862 * sp[18] + -0.04349267900155115 * sp[17];
    A[43] = -0.02319710902993958 * sp[19] + 0.001288728279440813 * sp[18] + 0.03221820698602824 * sp[18] + -0.01804219591217494 * sp[17];
    A[44] = -0.0620039682539692 * sp[19] + 0.1460813492063478 * sp[18] + 0.04092261904761985 * sp[18] + -0.06498015873016035 * sp[17];
    A[45] = -0.0154265873015874 * sp[19] + 0.009052579365079369 * sp[18] + -0.0244791666666668 * sp[18] + 0.01860119047619061 * sp[17];
    A[46] = 0.01746031746031737 * sp[19] + -0.004216269841269746 * sp[18] + 0.02316468253968249 * sp[18] + -0.01041666666666663 * sp[17];
    A[47] = -0.02385912698412702 * sp[19] + 0.00880456349206353 * sp[18] + -0.03067956349206362 * sp[18] + 0.01314484126984127 * sp[17];
    A[48] = 0.02162698412698431 * sp[19] + 0.03278769841269867 * sp[18] + 0.03278769841269867 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.02986111111111124 * sp[19] + -0.03581349206349217 * sp[18] + -0.03978174603174631 * sp[18] + -0.09444444444444483 * sp[17];
    A[50] = 0.01765873015873008 * sp[19] + 0.02237103174603166 * sp[18] + 0.02237103174603172 * sp[18] + 0.04474206349206342 * sp[17];
    A[51] = 0.02058531746031758 * sp[19] + 0.0135168650793652 * sp[18] + 0.07879464285714323 * sp[18] + 0.0205853174603176 * sp[17];
    A[52] = -0.02777777777777796 * sp[19] + -0.01364087301587308 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761926 * sp[17];
    A[53] = 0.01314484126984128 * sp[19] + 0.004340277777777709 * sp[18] + 0.04382440476190491 * sp[18] + 0.01116071428571433 * sp[17];
    A[54] = -0.07856742013183687 * sp[19] + 0.02665680325901707 * sp[18] + -0.152925871328041 * sp[18] + 0.04208968935634273 * sp[17];
    A[55] = -0.03522523963805745 * sp[19] + 0.07947157723220388 * sp[18] + 0.02104922856420335 * sp[18] + 0.1159855451497027 * sp[17];
    A[56] = -0.0451388888888881 * sp[19] + 0.04340277777777805 * sp[18] + 0.005704365079364801 * sp[18] + 0.05208333333333294 * sp[17];
    A[57] = 0.03507474113028566 * sp[19] + -0.09329881140655678 * sp[18] + 0.04700015311458293 * sp[18] + -0.2062394778460752 * sp[17];
    A[58] = 0.1005208057964093 * sp[19] + 0.03737312010379386 * sp[18] + 0.1714008611656716 * sp[18] + 0.1933092419161691 * sp[17];
    A[59] = 0.06200396825396922 * sp[19] + -0.0339781746031728 * sp[18] + 0.08308531746031894 * sp[18] + 0.04017857142857442 * sp[17];
    A[60] = 0.01746031746031738 * sp[19] + -0.005704365079365067 * sp[18] + 0.02167658730158715 * sp[18] + -0.01190476190476188 * sp[17];
    A[61] = -0.04384920634920631 * sp[19] + 0.009424603174603186 * sp[18] + -0.05327380952380961 * sp[18] + 0.01785714285714287 * sp[17];
    A[62] = 0.06111111111111146 * sp[19] + -0.01413690476190483 * sp[18] + 0.07276785714285766 * sp[18] + -0.02777777777777794 * sp[17];
    A[63] = -0.02986111111111124 * sp[19] + -0.03978174603174631 * sp[18] + -0.03581349206349217 * sp[18] + -0.09444444444444483 * sp[17];
    A[64] = 0.06865079365079409 * sp[19] + 0.08154761904761965 * sp[18] + 0.08154761904761965 * sp[18] + 0.1630952380952393 * sp[17];
    A[65] = -0.04871031746031756 * sp[19] + -0.05466269841269854 * sp[18] + -0.05863095238095262 * sp[18] + -0.09444444444444489 * sp[17];
    A[66] = -0.02529761904761932 * sp[19] + -0.01364087301587311 * sp[18] + -0.1005456349206357 * sp[18] + -0.02777777777777799 * sp[17];
    A[67] = 0.01785714285714303 * sp[19] + 0.008432539682539698 * sp[18] + 0.07113095238095261 * sp[18] + 0.01785714285714289 * sp[17];
    A[68] = -0.01041666666666669 * sp[19] + -0.006200396825396842 * sp[18] + -0.03358134920634919 * sp[18] + -0.01190476190476192 * sp[17];
    A[69] = 0.1487169023924088 * sp[19] + 0.002805979290422852 * sp[18] + 0.2946278254943955 * sp[18];
    A[70] = -0.006873217490354237 * sp[19] + -0.04725337024617485 * sp[18] + -0.1778445025628791 * sp[18] + -0.1030982623552908 * sp[17];
    A[71] = 0.1289682539682536 * sp[19] + -0.0917658730158737 * sp[18] + -0.01636904761904694 * sp[18] + -0.1785714285714299 * sp[17];
    A[72] = -0.07014948226057137 * sp[19] + 0.06594051332493445 * sp[18] + -0.07997040977705133 * sp[18] + 0.1346870059402926 * sp[17];
    A[73] = -0.04639421805988028 * sp[19] + 0.002577456558881605 * sp[18] + -0.0592815008542906 * sp[18] + -0.04123930494211521 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.1165674603174582 * sp[18] + -0.1413690476190499 * sp[18] + 0.1428571428571434 * sp[17];
    A[75] = -0.02385912698412701 * sp[19] + 0.006820436507936537 * sp[18] + -0.03266369047619058 * sp[18] + 0.01116071428571419 * sp[17];
    A[76] = 0.06111111111111138 * sp[19] + -0.01165674603174612 * sp[18] + 0.07524801587301631 * sp[18] + -0.02529761904761915 * sp[17];
    A[77] = -0.0511408730158732 * sp[19] + 0.007068452380952334 * sp[18] + -0.05820932539682566 * sp[18] + 0.02058531746031753 * sp[17];
    A[78] = 0.01765873015873008 * sp[19] + 0.02237103174603172 * sp[18] + 0.02237103174603166 * sp[18] + 0.04474206349206342 * sp[17];
    A[79] = -0.04871031746031756 * sp[19] + -0.05863095238095262 * sp[18] + -0.05466269841269854 * sp[18] + -0.09444444444444489 * sp[17];
    A[80] = 0.05734126984127007 * sp[19] + 0.06850198412698449 * sp[18] + 0.06850198412698449 * sp[18] + 0.1012896825396833 * sp[17];
    A[81] = 0.01116071428571434 * sp[19] + 0.004340277777777708 * sp[18] + 0.04382440476190495 * sp[18] + 0.01314484126984126 * sp[17];
    A[82] = -0.011904761904762 * sp[19] + -0.006200396825396838 * sp[18] + -0.03358134920634911 * sp[18] + -0.01041666666666656 * sp[17];
    A[83] = 0.01860119047619068 * sp[19] + 0.009548611111111226 * sp[18] + 0.04308035714285743 * sp[18] + 0.01860119047619056 * sp[17];
    A[84] = -0.0897913372935293 * sp[19] + -0.0154328860973257 * sp[18] + -0.1950155606843837 * sp[18] + -0.04208968935634282 * sp[17];
    A[85] = -0.0266337177751173 * sp[19] + -0.01073940232867694 * sp[18] + -0.007302793583500597 * sp[18] + -0.01288728279441238 * sp[17];
    A[86] = -0.0381944444444424 * sp[19] + 0.03596230158730121 * sp[18] + 0.1054067460317484 * sp[18] + 0.1264880952380961 * sp[17];
    A[87] = -0.03507474113028569 * sp[19] + -0.09750778034219186 * sp[18] + -0.05822407027627426 * sp[18] + -0.1641497884897319 * sp[17];
    A[88] = 0.02319710902993959 * sp[19] + 0.02448583730938077 * sp[18] + 0.05541531601596782 * sp[18] + 0.07474624020758434 * sp[17];
    A[89] = -0.06200396825396931 * sp[19] + -0.2080853174603167 * sp[18] + -0.1029265873015891 * sp[18] + -0.313988095238098 * sp[17];
    A[90] = -0.01314484126984128 * sp[19] + 0.03067956349206365 * sp[18] + -0.008804563492063535 * sp[18] + 0.02385912698412708 * sp[17];
    A[91] = 0.01041666666666667 * sp[19] + -0.02316468253968255 * sp[18] + 0.004216269841269756 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619066 * sp[19] + 0.02447916666666682 * sp[18] + -0.009052579365079394 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031758 * sp[19] + 0.07879464285714323 * sp[18] + 0.0135168650793652 * sp[18] + 0.0205853174603176 * sp[17];
    A[94] = -0.02529761904761932 * sp[19] + -0.1005456349206357 * sp[18] + -0.01364087301587311 * sp[18] + -0.02777777777777799 * sp[17];
    A[95] = 0.01116071428571434 * sp[19] + 0.04382440476190495 * sp[18] + 0.004340277777777708 * sp[18] + 0.01314484126984126 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269871 * sp[18] + 0.03278769841269871 * sp[18] + 0.02162698412698434 * sp[17];
    A[97] = -0.09444444444444483 * sp[19] + -0.03978174603174629 * sp[18] + -0.03581349206349219 * sp[18] + -0.02986111111111127 * sp[17];
    A[98] = 0.04474206349206346 * sp[19] + 0.02237103174603179 * sp[18] + 0.02237103174603173 * sp[18] + 0.01765873015873017 * sp[17];
    A[99] = -0.2062394778460754 * sp[19] + 0.04700015311458264 * sp[18] + -0.09329881140655702 * sp[18] + 0.0350747411302855 * sp[17];
    A[100] = 0.1314502845029979 * sp[19] + 0.1576544261849665 * sp[18] + -0.01073940232867412 * sp[18] + 0.1039574145415857 * sp[17];
    A[101] = 0.1473214285714276 * sp[19] + 0.1068948412698421 * sp[18] + 0.0493551587301591 * sp[18] + 0.05605158730158805 * sp[17];
    A[102] = 0.04208968935634289 * sp[19] + -0.1529258713280411 * sp[18] + 0.02665680325901719 * sp[18] + -0.0785674201318368 * sp[17];
    A[103] = 0.1030982623552904 * sp[19] + 0.01546473935329271 * sp[18] + 0.07732369676646848 * sp[18] + -0.05670404429540891 * sp[17];
    A[104] = 0.07440476190476319 * sp[19] + 0.01537698412698303 * sp[18] + 0.0471230158730168 * sp[18] + -0.007936507936507863 * sp[17];
    A[105] = 0.02777777777777799 * sp[19] + -0.07276785714285772 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111162 * sp[17];
    A[106] = -0.01785714285714302 * sp[19] + 0.05327380952380981 * sp[18] + -0.009424603174603228 * sp[18] + 0.04384920634920658 * sp[17];
    A[107] = 0.011904761904762 * sp[19] + -0.02167658730158726 * sp[18] + 0.005704365079365083 * sp[18] + -0.01746031746031749 * sp[17];
    A[108] = -0.02777777777777796 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587308 * sp[18] + -0.02529761904761926 * sp[17];
    A[109] = 0.01785714285714303 * sp[19] + 0.07113095238095261 * sp[18] + 0.008432539682539698 * sp[18] + 0.01785714285714289 * sp[17];
    A[110] = -0.011904761904762 * sp[19] + -0.03358134920634911 * sp[18] + -0.006200396825396838 * sp[18] + -0.01041666666666656 * sp[17];
    A[111] = -0.09444444444444483 * sp[19] + -0.03581349206349219 * sp[18] + -0.03978174603174629 * sp[18] + -0.02986111111111127 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761965 * sp[18] + 0.08154761904761965 * sp[18] + 0.06865079365079421 * sp[17];
    A[113] = -0.0944444444444449 * sp[19] + -0.05863095238095283 * sp[18] + -0.05466269841269865 * sp[18] + -0.04871031746031781 * sp[17];
    A[114] = 0.1346870059402924 * sp[19] + -0.0799704097770509 * sp[18] + 0.06594051332493431 * sp[18] + -0.07014948226057105 * sp[17];
    A[115] = 0.1030982623552916 * sp[19] + -0.152069936974054 * sp[18] + 0.1022391101689945 * sp[18] + -0.1305911323167021 * sp[17];
    A[116] = -0.1071428571428562 * sp[19] + 0.01934523809524017 * sp[18] + -0.05605158730158707 * sp[18] + 0.02182539682539814 * sp[17];
    A[117] = 0.2946278254943948 * sp[18] + 0.002805979290422813 * sp[18] + 0.1487169023924084 * sp[17];
    A[118] = -0.2061965247105821 * sp[19] + -0.1030982623552909 * sp[18] + -0.103098262355291 * sp[18] + 0.1082531754730537 * sp[17];
    A[119] = -0.145833333333337 * sp[18] + 0.004960317460317453 * sp[18] + -0.07043650793651011 * sp[17];
    A[120] = -0.02058531746031762 * sp[19] + 0.05820932539682571 * sp[18] + -0.007068452380952371 * sp[18] + 0.05114087301587342 * sp[17];
    A[121] = 0.02529761904761936 * sp[19] + -0.07524801587301651 * sp[18] + 0.01165674603174616 * sp[18] + -0.06111111111111168 * sp[17];
    A[122] = -0.01116071428571439 * sp[19] + 0.03266369047619067 * sp[18] + -0.006820436507936581 * sp[18] + 0.02385912698412714 * sp[17];
    A[123] = 0.01314484126984128 * sp[19] + 0.04382440476190491 * sp[18] + 0.004340277777777709 * sp[18] + 0.01116071428571433 * sp[17];
    A[124] = -0.01041666666666669 * sp[19] + -0.03358134920634919 * sp[18] + -0.006200396825396842 * sp[18] + -0.01190476190476192 * sp[17];
    A[125] = 0.01860119047619068 * sp[19] + 0.04308035714285743 * sp[18] + 0.009548611111111226 * sp[18] + 0.01860119047619056 * sp[17];
    A[126] = 0.04474206349206346 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603179 * sp[18] + 0.01765873015873017 * sp[17];
    A[127] = -0.0944444444444449 * sp[19] + -0.05466269841269865 * sp[18] + -0.05863095238095283 * sp[18] + -0.04871031746031781 * sp[17];
    A[128] = 0.1012896825396834 * sp[19] + 0.06850198412698472 * sp[18] + 0.06850198412698472 * sp[18] + 0.05734126984127041 * sp[17];
    A[129] = -0.1641497884897318 * sp[19] + -0.05822407027627446 * sp[18] + -0.09750778034219226 * sp[18] + -0.03507474113028581 * sp[17];
    A[130] = -0.2345485468582885 * sp[19] + -0.06142938132002928 * sp[18] + -0.1679642524204941 * sp[18] + -0.0420984571284117 * sp[17];
    A[131] = 0.2217261904761905 * sp[19] + 0.09945436507936538 * sp[18] + 0.1252480158730154 * sp[18] + 0.05109126984126966 * sp[17];
    A[132] = -0.04208968935634275 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732564 * sp[18] + -0.08979133729352942 * sp[17];
    A[133] = 0.1030982623552906 * sp[19] + 0.08763352300199809 * sp[18] + 0.02577456558882203 * sp[18] + -0.04639421805987948 * sp[17];
    A[134] = -0.07440476190476307 * sp[19] + -0.05902777777777964 * sp[18] + -0.02728174603174637 * sp[18] + -0.003968253968254362 * sp[17];
    A[135] = 0.04349267900155106 * sp[19] + -0.06243303921190632 * sp[18] + -0.02314932914598859 * sp[18] + 0.03507474113028557 * sp[17];
    A[136] = -0.07856742013183721 * sp[19] + 0.1360899955855055 * sp[18] + -0.009820927516479953 * sp[18] + 0.07014948226057133 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368425 * sp[18] + 0.01192541198429718 * sp[18] + -0.03507474113028566 * sp[17];
    A[138] = -0.07856742013183687 * sp[19] + -0.152925871328041 * sp[18] + 0.02665680325901707 * sp[18] + 0.04208968935634273 * sp[17];
    A[139] = 0.1487169023924088 * sp[19] + 0.2946278254943955 * sp[18] + 0.002805979290422852 * sp[18];
    A[140] = -0.0897913372935293 * sp[19] + -0.1950155606843837 * sp[18] + -0.0154328860973257 * sp[18] + -0.04208968935634282 * sp[17];
    A[141] = -0.2062394778460754 * sp[19] + -0.09329881140655702 * sp[18] + 0.04700015311458264 * sp[18] + 0.0350747411302855 * sp[17];
    A[142] = 0.1346870059402924 * sp[19] + 0.06594051332493431 * sp[18] + -0.0799704097770509 * sp[18] + -0.07014948226057105 * sp[17];
    A[143] = -0.1641497884897318 * sp[19] + -0.09750778034219226 * sp[18] + -0.05822407027627446 * sp[18] + -0.03507474113028581 * sp[17];
    A[144] = 4.920634920634908 * sp[19] + 0.1984126984127017 * sp[18] + 0.1984126984127017 * sp[18] + 0.3968253968254026 * sp[17];
    A[145] = 0.02430049347996821 * sp[19] + -0.06075123369997182 * sp[18] + 0.2308546880599291 * sp[18] + 0.607512336999805 * sp[17];
    A[146] = -0.5191061687282026 * sp[19] + -0.8067190459965525 * sp[18] + -0.3016427737204517 * sp[18] + -0.3507474113028564 * sp[17];
    A[147] = -0.1984126984127016 * sp[19] + 4.305555555555534 * sp[18] + 0.01984126984127003 * sp[18] + -0.1984126984127009 * sp[17];
    A[148] = -0.218704441319909 * sp[19] + -0.03645074021999062 * sp[18] + 0.2551551815399186 * sp[18] + -0.2187044413199267 * sp[17];
    A[149] = -0.3507474113028564 * sp[19] + 0.5401510134063892 * sp[18] + 0.03507474113028543 * sp[18] + 0.3226876183986328 * sp[17];
    A[150] = 0.06529556615835221 * sp[19] + -0.1271545235715238 * sp[18] + -0.05154913117764581 * sp[18] + 0.06529556615835085 * sp[17];
    A[151] = -0.05326743555023493 * sp[19] + 0.1838585678669348 * sp[18] + -0.008591521862941652 * sp[18] + 0.08419691425682242 * sp[17];
    A[152] = -0.003436608745177509 * sp[19] + -0.0515491311776443 * sp[18] + -0.0171830437258813 * sp[18] + -0.003436608745176609 * sp[17];
    A[153] = -0.03522523963805745 * sp[19] + 0.02104922856420335 * sp[18] + 0.07947157723220388 * sp[18] + 0.1159855451497027 * sp[17];
    A[154] = -0.006873217490354237 * sp[19] + -0.1778445025628791 * sp[18] + -0.04725337024617485 * sp[18] + -0.1030982623552908 * sp[17];
    A[155] = -0.0266337177751173 * sp[19] + -0.007302793583500597 * sp[18] + -0.01073940232867694 * sp[18] + -0.01288728279441238 * sp[17];
    A[156] = 0.1314502845029979 * sp[19] + -0.01073940232867412 * sp[18] + 0.1576544261849665 * sp[18] + 0.1039574145415857 * sp[17];
    A[157] = 0.1030982623552916 * sp[19] + 0.1022391101689945 * sp[18] + -0.152069936974054 * sp[18] + -0.1305911323167021 * sp[17];
    A[158] = -0.2345485468582885 * sp[19] + -0.1679642524204941 * sp[18] + -0.06142938132002928 * sp[18] + -0.0420984571284117 * sp[17];
    A[159] = 0.02430049347996821 * sp[19] + 0.2308546880599291 * sp[18] + -0.06075123369997182 * sp[18] + 0.607512336999805 * sp[17];
    A[160] = 5.416666666666707 * sp[19] + 0.4315476190476334 * sp[18] + 0.4315476190476334 * sp[18] + 1.130952380952397 * sp[17];
    A[161] = -0.1890134809847078 * sp[19] + -0.06873217490352201 * sp[18] + -0.2749286996141036 * sp[18] + -0.1890134809847015 * sp[17];
    A[162] = 0.1701034543599521 * sp[19] + 0.4495591293798418 * sp[18] + 0.1579532076199494 * sp[18] + -0.4131083891598584 * sp[17];
    A[163] = -0.4017857142857231 * sp[19] + 3.593749999999991 * sp[18] + 0.5580357142857229 * sp[18] + -0.4017857142857128 * sp[17];
    A[164] = 0.3007032652029462 * sp[19] + 0.1761261981902896 * sp[18] + 0.2792244605455822 * sp[18] + 0.3007032652029432 * sp[17];
    A[165] = -0.0168650793650814 * sp[19] + 0.07192460317460277 * sp[18] + -0.007440476190475747 * sp[18] + -0.0109126984126997 * sp[17];
    A[166] = -0.004960317460314351 * sp[19] + -0.162698412698412 * sp[18] + 0.01984126984126908 * sp[18] + -0.1021825396825402 * sp[17];
    A[167] = 0.1001984126984117 * sp[19] + 0.1026785714285716 * sp[18] + -0.07192460317460359 * sp[18] + 0.1180555555555571 * sp[17];
    A[168] = -0.0451388888888881 * sp[19] + 0.005704365079364801 * sp[18] + 0.04340277777777805 * sp[18] + 0.05208333333333294 * sp[17];
    A[169] = 0.1289682539682536 * sp[19] + -0.01636904761904694 * sp[18] + -0.0917658730158737 * sp[18] + -0.1785714285714299 * sp[17];
    A[170] = -0.0381944444444424 * sp[19] + 0.1054067460317484 * sp[18] + 0.03596230158730121 * sp[18] + 0.1264880952380961 * sp[17];
    A[171] = 0.1473214285714276 * sp[19] + 0.0493551587301591 * sp[18] + 0.1068948412698421 * sp[18] + 0.05605158730158805 * sp[17];
    A[172] = -0.1071428571428562 * sp[19] + -0.05605158730158707 * sp[18] + 0.01934523809524017 * sp[18] + 0.02182539682539814 * sp[17];
    A[173] = 0.2217261904761905 * sp[19] + 0.1252480158730154 * sp[18] + 0.09945436507936538 * sp[18] + 0.05109126984126966 * sp[17];
    A[174] = -0.5191061687282026 * sp[19] + -0.3016427737204517 * sp[18] + -0.8067190459965525 * sp[18] + -0.3507474113028564 * sp[17];
    A[175] = -0.1890134809847078 * sp[19] + -0.2749286996141036 * sp[18] + -0.06873217490352201 * sp[18] + -0.1890134809847015 * sp[17];
    A[176] = 5.555555555555568 * sp[19] + 0.5902777777777786 * sp[18] + 0.5902777777777786 * sp[18] + 0.912698412698428 * sp[17];
    A[177] = -0.3507474113028573 * sp[19] + -0.3016427737204449 * sp[18] + 0.2034334985556574 * sp[18] + -0.01402989645209582 * sp[17];
    A[178] = 0.07732369676647569 * sp[19] + 0.1675346763273481 * sp[18] + 0.06443641397205582 * sp[18] + 0.07732369676647199 * sp[17];
    A[179] = -0.6200396825396938 * sp[19] + 3.395337301587296 * sp[18] + 0.3596230158730227 * sp[18] + -0.6200396825397005 * sp[17];
    A[180] = 0.03507474113028576 * sp[19] + -0.01192541198429705 * sp[18] + 0.1283735525368425 * sp[18] + -0.1248660784238148 * sp[17];
    A[181] = -0.07014948226057144 * sp[19] + 0.009820927516479908 * sp[18] + -0.1360899955855055 * sp[18] + 0.07856742013183715 * sp[17];
    A[182] = -0.03507474113028564 * sp[19] + 0.02314932914598862 * sp[18] + 0.06243303921190642 * sp[18] + -0.04349267900155115 * sp[17];
    A[183] = 0.03507474113028566 * sp[19] + 0.04700015311458293 * sp[18] + -0.09329881140655678 * sp[18] + -0.2062394778460752 * sp[17];
    A[184] = -0.07014948226057137 * sp[19] + -0.07997040977705133 * sp[18] + 0.06594051332493445 * sp[18] + 0.1346870059402926 * sp[17];
    A[185] = -0.03507474113028569 * sp[19] + -0.05822407027627426 * sp[18] + -0.09750778034219186 * sp[18] + -0.1641497884897319 * sp[17];
    A[186] = 0.04208968935634289 * sp[19] + 0.02665680325901719 * sp[18] + -0.1529258713280411 * sp[18] + -0.0785674201318368 * sp[17];
    A[187] = 0.002805979290422813 * sp[18] + 0.2946278254943948 * sp[18] + 0.1487169023924084 * sp[17];
    A[188] = -0.04208968935634275 * sp[19] + -0.01543288609732564 * sp[18] + -0.1950155606843832 * sp[18] + -0.08979133729352942 * sp[17];
    A[189] = -0.1984126984127016 * sp[19] + 0.01984126984127003 * sp[18] + 4.305555555555534 * sp[18] + -0.1984126984127009 * sp[17];
    A[190] = 0.1701034543599521 * sp[19] + 0.1579532076199494 * sp[18] + 0.4495591293798418 * sp[18] + -0.4131083891598584 * sp[17];
    A[191] = -0.3507474113028573 * sp[19] + 0.2034334985556574 * sp[18] + -0.3016427737204449 * sp[18] + -0.01402989645209582 * sp[17];
    A[192] = 0.3968253968254035 * sp[19] + 0.1984126984127014 * sp[18] + 0.1984126984127014 * sp[18] + 4.920634920634909 * sp[17];
    A[193] = -0.1458029608799466 * sp[18] + -0.7290148043997473 * sp[18] + -0.4374088826398554 * sp[17];
    A[194] = 0.7014948226057136 * sp[19] + 0.3507474113028564 * sp[18] + 0.3507474113028566 * sp[18] + 0.2805979290422596 * sp[17];
    A[195] = -0.1005208057964096 * sp[19] + 0.07088005536926235 * sp[18] + -0.06314768569261574 * sp[18] + -0.08505606644311357 * sp[17];
    A[196] = 0.04639421805988044 * sp[19] + -0.01288728279441046 * sp[18] + 0.04897167461876219 * sp[18] + 0.0309294787065859 * sp[17];
    A[197] = -0.02319710902993958 * sp[19] + 0.03221820698602824 * sp[18] + 0.001288728279440813 * sp[18] + -0.01804219591217494 * sp[17];
    A[198] = 0.1005208057964093 * sp[19] + 0.1714008611656716 * sp[18] + 0.03737312010379386 * sp[18] + 0.1933092419161691 * sp[17];
    A[199] = -0.04639421805988028 * sp[19] + -0.0592815008542906 * sp[18] + 0.002577456558881605 * sp[18] + -0.04123930494211521 * sp[17];
    A[200] = 0.02319710902993959 * sp[19] + 0.05541531601596782 * sp[18] + 0.02448583730938077 * sp[18] + 0.07474624020758434 * sp[17];
    A[201] = 0.1030982623552904 * sp[19] + 0.07732369676646848 * sp[18] + 0.01546473935329271 * sp[18] + -0.05670404429540891 * sp[17];
    A[202] = -0.2061965247105821 * sp[19] + -0.103098262355291 * sp[18] + -0.1030982623552909 * sp[18] + 0.1082531754730537 * sp[17];
    A[203] = 0.1030982623552906 * sp[19] + 0.02577456558882203 * sp[18] + 0.08763352300199809 * sp[18] + -0.04639421805987948 * sp[17];
    A[204] = -0.218704441319909 * sp[19] + 0.2551551815399186 * sp[18] + -0.03645074021999062 * sp[18] + -0.2187044413199267 * sp[17];
    A[205] = -0.4017857142857231 * sp[19] + 0.5580357142857229 * sp[18] + 3.593749999999991 * sp[18] + -0.4017857142857128 * sp[17];
    A[206] = 0.07732369676647569 * sp[19] + 0.06443641397205582 * sp[18] + 0.1675346763273481 * sp[18] + 0.07732369676647199 * sp[17];
    A[207] = -0.7290148043997473 * sp[18] + -0.1458029608799466 * sp[18] + -0.4374088826398554 * sp[17];
    A[208] = 0.8035714285714428 * sp[19] + 0.4017857142857206 * sp[18] + 0.4017857142857206 * sp[18] + 5.357142857142859 * sp[17];
    A[209] = -0.05154913117763665 * sp[18] + -0.2577456558882183 * sp[18] + -0.1546473935329274 * sp[17];
    A[210] = 0.06200396825396943 * sp[19] + -0.0210813492063494 * sp[18] + 0.09598214285714192 * sp[18] + 0.05307539682539857 * sp[17];
    A[211] = -0.1240079365079387 * sp[19] + 0.01736111111111123 * sp[18] + -0.2405753968253961 * sp[18] + 0.04365079365079525 * sp[17];
    A[212] = -0.0620039682539692 * sp[19] + 0.04092261904761985 * sp[18] + 0.1460813492063478 * sp[18] + -0.06498015873016035 * sp[17];
    A[213] = 0.06200396825396922 * sp[19] + 0.08308531746031894 * sp[18] + -0.0339781746031728 * sp[18] + 0.04017857142857442 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.1413690476190499 * sp[18] + 0.1165674603174582 * sp[18] + 0.1428571428571434 * sp[17];
    A[215] = -0.06200396825396931 * sp[19] + -0.1029265873015891 * sp[18] + -0.2080853174603167 * sp[18] + -0.313988095238098 * sp[17];
    A[216] = 0.07440476190476319 * sp[19] + 0.0471230158730168 * sp[18] + 0.01537698412698303 * sp[18] + -0.007936507936507863 * sp[17];
    A[217] = 0.004960317460317453 * sp[18] + -0.145833333333337 * sp[18] + -0.07043650793651011 * sp[17];
    A[218] = -0.07440476190476307 * sp[19] + -0.02728174603174637 * sp[18] + -0.05902777777777964 * sp[18] + -0.003968253968254362 * sp[17];
    A[219] = -0.3507474113028564 * sp[19] + 0.03507474113028543 * sp[18] + 0.5401510134063892 * sp[18] + 0.3226876183986328 * sp[17];
    A[220] = 0.3007032652029462 * sp[19] + 0.2792244605455822 * sp[18] + 0.1761261981902896 * sp[18] + 0.3007032652029432 * sp[17];
    A[221] = -0.6200396825396938 * sp[19] + 0.3596230158730227 * sp[18] + 3.395337301587296 * sp[18] + -0.6200396825397005 * sp[17];
    A[222] = 0.7014948226057136 * sp[19] + 0.3507474113028566 * sp[18] + 0.3507474113028564 * sp[18] + 0.2805979290422596 * sp[17];
    A[223] = -0.2577456558882183 * sp[18] + -0.05154913117763665 * sp[18] + -0.1546473935329274 * sp[17];
    A[224] = 1.240079365079386 * sp[19] + 0.6200396825396922 * sp[18] + 0.6200396825396922 * sp[18] + 5.615079365079415 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
